app.directive('ngmoeda', ['$filter', function ($filter) {
    return {
        require: '?ngModel',
        link: function (scope, elem, attrs, ctrl) {
            if (!ctrl) return;


            ctrl.$formatters.unshift(function (a) {
                return $filter(attrs.format)(ctrl.$modelValue);
            });


            ctrl.$parsers.unshift(function (viewValue) {
                              
          elem.priceFormat({
            prefix: '',
            centsSeparator: ',',
            thousandsSeparator: '.'
        });                
                         
                return elem[0].value;
            });
        }
    };
}]);

app.directive('imgnotfoundnotific',
    function () {
        return {
            link: function (scope, element, attrs) {
                $(element).error(function(){
                    $(this).attr('src', './img/imgnotfoundnotific.png');
                });
            }
        };
    });
app.directive('imgnotfound',
    function () {
        return {
            link: function (scope, element, attrs) {
                $(element).error(function(){
                    $(this).attr('src', './img/imgnotfound.gif');
                });
            }
        };
    });
app.directive('fotonotfound',
    function () {
        return {
            link: function (scope, element, attrs) {
                $(element).error(function(){
                    $(this).attr('src', './img/fotonotfound.gif');
                });
            }
        };
    }); 
app.directive('imgnotfoundblank',
    function () {
        return {
            link: function (scope, element, attrs) {
                $(element).error(function(){
                    $(this).attr('src', './img/imgnotfoundblank.png');
                });
            }
        };
    });  
    
app.directive('backImg',
    function () {
        return {
            link: function (scope, element, attrs) {                
                var url = attrs.backImg;
                element.css({
                    'background-image': 'url(' + url +')',
                    'background-size' : 'cover'
                });
                componentHandler.upgradeAllRegistered();
            }
        };
    });

app.directive('mHeader', function(){
    return {
        restrict: 'EA',
        templateUrl: 'app/tpls/mHeader.html',
        replace: true,
        controller: function($scope, $rootScope, loginService){
            
            $scope.setLogout = function(){
                loginService.setLogout();
            };
        },
        link: function(scope, el, attr){
            componentHandler.upgradeAllRegistered();
        }
    }; 
});

app.directive('menuR', function(){
    return {
        restrict: 'EA',
        templateUrl: 'app/tpls/menuR.html',
        scope: {
            corIcon: "@"
        },
        replace: true,
        controller: function($scope, $rootScope, Util, loginService){   
            $scope.corIcon = 'white';
            $scope.APP_INDIVIDUAL = $rootScope.APP_INDIVIDUAL;
            $scope.lg = $rootScope.lg;
            $scope.path_foto_us = $rootScope.rootUrlFotoUs+$rootScope.dispIg.ig_cod;
            
            $rootScope.$watch('lg', function(){
                $scope.lg = $rootScope.lg;
                $scope.setRandom();
            });
            
            $scope.setRandom = function(){
                $scope.random = Util.random(10000);
            };
            
            $scope.setLogout = function(){
                loginService.setLogout();
            };
            
            $scope.getUrlFotoUs = function(){
                return Util.getUrlFotoUs($rootScope.lg.us_cod);
            };
            
            $scope.openInAppBrowserAdministracao= function(){
                
                var url = $rootScope.root+""+"loginApp.php?app="+$rootScope.APP_BD+"&inst="+$rootScope.APP_INS_COD+"&ig="+$rootScope.dispIg.ig_cod+"&us="+$rootScope.lg.us_cod+"&tk="+localStorage.getItem('lg_token_session')+"&rd="+Util.random(10000);
                
                var isOffline = 'onLine' in navigator && !navigator.onLine;
                if(isOffline){
                    window.plugins.toast.showLongCenter('Verifique sua conexão com a internet.');                    
                }else{
                    //window.open(url, '_system', 'location=yes');
                    var ref = cordova.InAppBrowser.open(url, '_blank', 'location=yes,clearcache=yes,clearsessioncache=yes,zoom=no');
                }          
                
                return false;
            };
        },
        link: function(scope, el, attr){
            componentHandler.upgradeAllRegistered();
        }
    }; 
});

app.directive('searchPg', function(){
   return {
        restrict: 'AE',
        replace: true,
        scope: {
            search: "=search",
            search_modo: "=searchModo",
            search_change: "=searchChange",//pesquisa instantânea - true ou false;
            getSearch: "&onSearch"
        },
        templateUrl: 'app/tpls/search.html',
        controller: function($scope){
            $scope.search = "";
            $scope.search_modo = false;
            $scope.getAll = false;
            
            $scope.$watch('search', function(newValue, oldValue){                
                if($scope.search_change){
                    $scope.getSearch();
                }else{
                    if(newValue === "" && $scope.getAll){
                        $scope.getSearch();
                        $scope.getAll = false;
                    }
                }                    
            });
            $scope.$watch('search_modo', function(newValue, oldValue){
                if(!newValue && $scope.search.length > 0){  
                    $scope.getAll = true;
                    $scope.search = "";                    
                }               
            });
            $scope.submitFocus = function () {
                angular.element(':submit').focus();
                if(!$scope.search_change){
                    $scope.getSearch();
                }                    
            };        
            $scope.modoSearch = function(){
                $scope.search_modo = !$scope.search_modo;                            
            };
            $scope.onBlurSearch = function(){
                if($scope.search.length === 0){$scope.search_modo = false;}
                Keyboard.hide();//Fechar teclado
            };
            $scope.onFocusInputSearch = function(){
                Keyboard.show();//Abrir teclado
            };  
        },
        link: function (scope, el, attrs){
            componentHandler.upgradeAllRegistered();
        }
   };
});


app.directive('sobre', function(){
   return {
        restrict: 'EA',
        replace: true,
        templateUrl: 'app/tpls/sobre.html',
        controller: function($scope){
            $scope.openUrlBrowserSystem = function(url){
                window.open(url, '_system', 'location=yes');
            };
        }
   };
});


app.directive('notif', function(){
   return {
        restrict: 'EA',
        replace: true,
        templateUrl: 'app/tpls/notif.html',
        controller: function($scope, $rootScope, $location){
            $scope.openUrlBrowserSystem = function(url){
                window.open(url, '_system', 'location=yes');
            };
            
            $scope.locationRedirectApp = function(){
                $('#notifModal').modal('hide'); 
                $location.path($rootScope.btn_redirect_app);
            };
            
            $scope.getNomeBtn = function(r){
                var n = "";
                switch (r){
                    case 'nivers': 
                        n = "Aniversariantes";
                        break
                    case 'agenda': 
                        n = "Agenda";
                        break
                    case 'biblia': 
                        n = "Bíblia";
                        break
                    case 'celulas': 
                        n = "Células";
                        break
                    case 'contato': 
                        n = "Contato";
                        break
                    case 'doacao': 
                        n = "Doação";
                        break
                    case 'down': 
                        n = "Estudo";
                        break   
                    case 'minhascelulaslist': 
                        n = "Minha Célula";
                        break
                    case 'msgs': 
                        n = "Micro Blog";
                        break
                    case 'pedoracao': 
                        n = "Pedido de Oração";
                        break
                    case 'redecelulas': 
                        n = "Rede de Células";
                        break
                    case 'video': 
                        n = "Vídeos";
                        break

                    default:
                        n = r;
                }
                
                return n;
            };
        }
   };
});


app.directive('lightgallery',
    function () {
        return {
            link: function (scope, element, attrs) {
                        
                    if (scope.$last) { // ng-repeat is completed    
                        setTimeout(function(){
                            element.parent().lightGallery({
                                selector: '.item',
                                loop: false,
                                controls: false,
                                download: false,
                                hideBarsDelay: 3000 //Padrão 6000
                            }).on('onAfterSlide.lg', function(event, index, fromTouch, fromThumb){
                                //console.log(index +"-"+ fromTouch +"-"+ fromThumb);     
                                //angular.element("#scroll").animate({scrollTop: $('#fr_'+fromTouch).offset().top - 100}, 50);
                            });
                        },1*150);
                   }else{
                       if(element.parent().data('lightGallery')){
                           element.parent().data('lightGallery').destroy(true);
                       }                    
                   }                
                    
            }
        };
    });


/**
 * Directive - Mapa do goggle
 */
app.directive('mapa', function(){
    return {
        restrict: 'AE',
        transclude: false,
        replace: true,
        template: '<div id="mapa"><p class="text-center" style="padding: 25px;"><loader></loader> <span ng-show="loader">CARREGANDO MAPA...</span></p></div>',
        scope: {
            lat: '=',
            lng: '=',
            zoom: '=',
            tag: '=',
            onNotFoundLatLng: '&',
            onSuccess: '&',
            onError: '&'
        },
        controller: function($scope){
            var count_map_google_loader = 0;
            $scope.mapacreate = false;
            
            $scope.$watch('lat', function(newValue){
                if(newValue){
                    if(newValue.indexOf('mapa-') > -1) return false;
                }
                
                if(newValue){
                    if($scope.mapacreate){
                        $scope.clearMap();
                    }
                    $scope.init();
                }else{
                    if(newValue !== undefined){
                        if($scope.mapacreate){
                            $scope.clearMap();
                        }
                        $scope.onNotFoundLatLng();
                        $scope.onError();
                    }
                    $scope.lat = "mapa-"+Math.floor((Math.random() * 1000) + 1);
                }
            });
            
            $scope.init = function(){
                if (typeof google === 'object' && typeof google.maps === 'object') {//Verifica se já foi carregado
                    $scope.startMapa();
                }else{
                    $scope.loader = true;
                    $.getScript("http://maps.google.com/maps/api/js?sensor=true&callback=initializeMap")
                    .done(function (script, textStatus) {
                        setTimeout(function(){
                            var map_google_loader_ok = localStorage.getItem('map_google_loader_ok') ? true : false;
                            
                            if(map_google_loader_ok){
                                $scope.startMapa();
                                $scope.loader = false;
                            }else{
                                if(count_map_google_loader < 3){
                                    $scope.init();
                                }else{
                                    count_map_google_loader = 0;
                                    $scope.loader = false;
                                    window.plugins.toast.showLongCenter('Não foi possível carregar o mapa! Verifique sua conexão com a internet.');
                                    $scope.onError();
                                }                                
                            }                            
                        }, 2000);
                        count_map_google_loader++;
                    })
                    .fail(function (jqxhr, settings, ex) {
                        window.plugins.toast.showLongCenter('Não foi possível carregar o mapa! Verifique sua conexão com a internet.');
                        $scope.onError();
                    });
                }
            };
            
            $scope.startMapa = function(){
                count_map_google_loader = 0;
                if(!$scope.lat || !$scope.lng){                    
                    $scope.destroyMap();
                    return false;
                }
                
                if(!$scope.tag) $scope.tag = "mapa";
                if(!$scope.zoom) $scope.zoom = 18;

                $('#mapa').gmap3();

                $('#mapa').gmap3({
                    map: {
                        options: {
                            center: [$scope.lat, $scope.lng],
                            zoom: $scope.zoom
                        }
                    },
                    marker: {
                        values: [
                            {latLng: [$scope.lat, $scope.lng], tag: $scope.tag}
                        ]
                    }
                });
                $scope.onSuccess();
                $scope.mapacreate = true;
                $scope.lat = "mapa-"+Math.floor((Math.random() * 1000) + 1);
            };
            
            $scope.clearMap = function() {
                $('#mapa').gmap3({
                    clear: 'marker'
                });
            };

            $scope.destroyMap = function(){
                $('#mapa').gmap3('destroy');
                $scope.mapacreate = false;
            };
            
            //$scope.init();
        }
    };
});

app.directive('loader', function(){
    return {
        restrict: 'AE',
        transclude: false,
        replace: true,
        template: '<div ng-show="loader" class="block-center"><div style="margin-top: 10px;" class="mdl-spinner mdl-js-spinner is-active"></div></div>',
        link: function (scope, el, attrs){
            componentHandler.upgradeAllRegistered();
        }
    };
});


/**
 * A altura do textarea acompanha o texto adicionado ou copiado
 */
app.directive('textareaAutoHeight',
    function () {
        return {
            link: function (scope, element, attrs) {     
                var max = attrs.maxHeight;
                $(element).on('keyup onpaste', function () {
                    while( $(this).outerHeight() < this.scrollHeight +
                                        parseFloat($(this).css("borderTopWidth")) +
                             parseFloat($(this).css("borderBottomWidth"))
                             && $(this).height() < parseInt(max) // Altura máxima
                             ) {
                         $(this).height($(this).height() + 1);
                     }
                 });
            }
        };
    });

app.directive('mask',
    function () {
        return {
            link: function (scope, element, attrs) {                
                $(element).mask(attrs.mask, {clearIfNotMatch: true});
            }
        };
    });


app.directive('focusRange', function($timeout, $parse) {
  return {
    link: function(scope, element, attrs) {
      element.bind('click', function() {
          this.focus();
      });
    }
  };
});

app.directive('focusTop', function($timeout, $parse) {
  return {
    link: function(scope, element, attrs) {
      element.bind('focus', function() {
          //alert('Deus é fiel!');
          $('#scroll').scrollTo(0, element[0].offsetTop - 100);
      });
    }
  };
});



app.directive('focusMe', function($timeout, $parse) {
  return {
    //scope: true,   // optionally create a child scope
    link: function(scope, element, attrs) {
      var model = $parse(attrs.focusMe);
      scope.$watch(model, function(value) {
        //console.log('value=',value);
        if(value === true) { 
          $timeout(function() {
            element[0].focus(); 
          });
        }
      });
      // to address @blesh's comment, set attribute value to 'false'
      // on blur event:
      element.bind('blur', function() {
         //console.log('blur');
         //scope.$apply(model.assign(scope, false));
      });
    }
  };
});



/** SHOW BOOTSTRAP UI SIMPLES **/
app.directive('showtab',
    function () {
        return {
            link: function (scope, element, attrs) {
                element.click(function(e) {
                    e.preventDefault();
                    $(element).tab('show');
                });
            }
        };
    });
app.directive('showtooltip',
    function () {
        return {
            link: function (scope, element, attrs) {
                $(element).tooltip();
            }
        };
    });
app.directive('bsPopover', function() {
    return function(scope, element, attrs) {
        $(element).popover();
    };
});