app.filter('masktel', function (Util) {
    return function (input) {
        if(input){
            return Util.formatTelString(input);
        }            
    };
});

app.filter('maskcpf', function (Util) {
    return function (input) {
        if(input){
            return Util.formatCpfString(input);
        }            
    };
});

app.filter('maskcep', function (Util) {
    return function (input) {
        if(input){
            return Util.formatCepString(input);
        }            
    };
});

app.filter('datec', function ($filter) {
    return function (data, _f) {
        var f = _f ? _f : "dd/MM/yyyy";
        var tempdate = new Date(data.replace(/-/g, "/"));
        return $filter('date')(tempdate, f);
    };
});

app.filter('mestxt', function (Util) {
    var getTxtMes = function (mes, abrev) {
        return Util.getTxtMes(mes, abrev);
    };

    return function (mes, abrev) {
        return getTxtMes(mes, abrev);
    };
});

app.filter('semanatxt', function (Util) {
    var getSemanaTxt = function (dia, abrev) {
        return Util.getSemanaTxt(dia, abrev);
    };

    return function (dia, abrev) {
        return getSemanaTxt(dia, abrev);
    };
});

app.filter('nl2br', ['$sanitize', function($sanitize) {
    var tag = (/xhtml/i).test(document.doctype) ? '<br />' : '<br>';
    return function(msg) {
        // ngSanitize's linky filter changes \r and \n to &#10; and &#13; respectively
        msg = (msg + '').replace(/(\r\n|\n\r|\r|\n|&#10;&#13;|&#13;&#10;|&#10;|&#13;)/g, tag + '$1');
        return $sanitize(msg);
    };
}]);

app.filter('checktruefalse', function () {
    var getIconHtml = function (tipo, icon) {
        return tipo === 'fa' ? '<i class="fa fa-' + icon + '"></i>' : '<i class="glyphicon glyphicon-' + icon + '"></i>';
    };

    return function (input, icon_true, icon_false, tipo) {
        var icon = null;

        if (input === true || input === 'true' ||
                input === 1 || input === '1' ||
                input === 'SIM' || input === 'sim' || input === 'YES' || input === 'yes' ||
                input === 'S' || input === 's' || input === 'Y' || input === 'y' ||
                input === 'ATIVO' || input === 'ativo' || input === 'ACTIVE' || input === 'active' ||
                input === 'ok' || input === 'OK') {
            icon = icon_true ? icon_true : 'ok';
        } else
        {
            icon = icon_false ? icon_false : '';
        }

        return icon ? getIconHtml(tipo, icon) : '';
    };
});




