var app = angular.module('app', ['ngRoute','ngSanitize','appC','wfPagination','youtube-embed','ng-currency','ui.utils']);

/**
 * Config app
 * @param {type} param
 */
app.config(['$compileProvider', '$sceDelegateProvider', function($compileProvider, $sceDelegateProvider) {
    /**
     * !IMPORTANTE
     * http://stackoverflow.com/questions/22682770/unable-to-display-contact-photo-in-phonegap-through-angularjs
     * Isto resolve o problema do ng-src quando tenta ler imagens como "content://com.android.contacts/contacts/30/photo"
     */
    $compileProvider.imgSrcSanitizationWhitelist(/^\s*(https?|ftp|file|blob|content):|data:image\//);
    /** **/
    
    /**
     * LISTA BRANCA - POLÍTICA DO ANGULARJS
     */
    $sceDelegateProvider.resourceUrlWhitelist([
        // Allow same origin resource loads.
        'self',
        // Allow loading from our assets domain.  Notice the difference between * and **.
        'http://www.viscel.com.br/viscel_server/**',
        'http://viscel.com.br/viscel_server/**'
    ]);

    /**
     * LISTA NEGRA - POLÍTICA DO ANGULARJS
     */
    // The blacklist overrides the whitelist so the open redirect here is blocked.
    $sceDelegateProvider.resourceUrlBlacklist([
        'http://myapp.example.com/clickThru**'
    ]);
}]);


/**
 * run app
 * @param {type} param
 */
app.run(['$rootScope','loginService','$timeout', function ($rootScope, loginService, $timeout) {
        /**
         * Resolve problemas de renderização de CSS’s no Material Design Lite para dispositivos móveis
         * Artigo: http://www.horochovec.com.br/blog/2015/07/22/angularjs-material-design-lite-para-dispositivos-moveis/comment-page-1/#comment-1904
         */
        $rootScope.$on('$viewContentLoaded', function upgradeAllRegistered() {
            componentHandler.upgradeAllRegistered();
        });
        
        /*
            Receber mensagem emitida e transmiti-lo entre Controllers. Os nomes dos eventos devem ser distintos.
            Artigo: "comunicar diferentes controllers no AngularJs" 
            em http://nomadev.com.br/como-comunicar-diferentes-controllers-no-angularjs/
        */
        $rootScope.$on('handleEmit', function(event, args) {
            $rootScope.$broadcast('handleBroadcast', args);
        });
        
        /**
         * Pega a página anterior
         */
        $rootScope.$on('$locationChangeStart', function() {
            $rootScope.previousPage = location.pathname;
            angular.element("html body").scrollTop(0);            
        });
        
        $rootScope.lg = {};//Dados do Usuário Logado
        $rootScope.disp = {};//Dados do Dispositivo ativado
        $rootScope.dispIg = {};//Dados da Igreja ativada
        
        $rootScope.count = 0;//Para testes com timeout
        
        $rootScope.player_id_onesignal = "";
        $rootScope.redirect_app = "/";
        $rootScope.btn_redirect_app = "/";
                
        $rootScope.nfs = [];
        
        /* TIPO DE MÍDIA */
        $rootScope.MIDIA_NULL = 0;
        $rootScope.MIDIA_IMG = 1;
        $rootScope.MIDIA_VIDEO = 2;
        $rootScope.MIDIA_AUDIO = 3;
        
        $rootScope.rootUrlFotoUs = $rootScope.rootUrl+"us/";
        $rootScope.rootUrlLogoIgreja = $rootScope.rootUrl+"logo_ig/";
        $rootScope.rootUrlFotoReuniaoCel = $rootScope.rootUrl+"reuniao_cel/";
        
        $rootScope.navtop = {vis: false, title: '', btnBack: false};
        
        $rootScope.loader = false;
        
        /**
         * Para loader mensagem
         */
        $rootScope.msgs_perc = [];
        $rootScope.msgs_loader = [];
        /** **/
        
        $rootScope.online = false;
        
        /*** DEVICEREADY ***/
        $rootScope.deviceready = false;
        $rootScope.version_app = "";
        window.addEventListener('load', function() {
                document.addEventListener("deviceready", onDeviceReady, false); 
                document.addEventListener("online", onOnline, false);
                document.addEventListener("offline", onOffline, false);
        }, false);
        
        var logoutServerPending = function(){
            var logoutServerPendentToken = localStorage.getItem('logoutServerPendentToken') ? localStorage.getItem('logoutServerPendentToken') : null;

            if(logoutServerPendentToken){
                loginService.logoutServerPending(logoutServerPendentToken);
            }
        };
        var onOnline = function() {
            console.log("onOnline");
            $rootScope.online = true;
            logoutServerPending();
        };
        var onOffline = function() {
            console.log("onOffline");
            $rootScope.online = false;
        };
        
            
        var onDeviceReady = function(){
            $rootScope.deviceready = true;
            logoutServerPending();
            
            $rootScope.nfs = localStorage.getItem('nfs') ? JSON.parse(localStorage.getItem('nfs')) : [];
            var adicNotificLocalStorage = function(_nf){
                var nfs = localStorage.getItem('nfs') ? JSON.parse(localStorage.getItem('nfs')) : [];
                if(nfs.length > 5){
                    nfs.pop();//Elimina o primeiro elemento (mais antigo)
                }
                nfs.unshift(_nf);
                localStorage.setItem('nfs', JSON.stringify(nfs));
                $rootScope.nfs = nfs;
            };
            
            /****** ONSIGNAL ******/
            // Add to index.js or the first page that loads with your app.
            // For Intel XDK and please add this to your app.js.

            
            // Enable to debug issues.
            // window.plugins.OneSignal.setLogLevel({logLevel: 4, visualLevel: 4});

            var notificationOpenedCallback = function(jsonData) {
                //alert('notificationOpenedCallback: ' + JSON.stringify(jsonData));
                
                var rdn = Math.floor((Math.random() * 1000) + 1);
                var title = jsonData.notification.payload.title;
                var body  = jsonData.notification.payload.body;
                var largeIcon  = jsonData.notification.payload.largeIcon+'?'+rdn;
                var bigPicture  = jsonData.notification.payload.bigPicture+'?'+rdn;
                var data  = jsonData.notification.payload.additionalData;
                
                $timeout(function(){
                    if(data.acao == '1'){
                        $rootScope.$apply(function () {
                            $rootScope.nf = {
                                us_cod: data.us_cod,
                                us_nome: data.us_nome,
                                title: title,
                                message: body,
                                largeIcon: largeIcon,
                                bigPicture: bigPicture
                            };
                            $rootScope.btn_redirect_app = data.redirect_app ? data.redirect_app : '/';
                            adicNotificLocalStorage($rootScope.nf);
                        });

                        $('#notifModal').modal('show');
                    }else if(data.acao == '2' && data.redirect_app){
                        $rootScope.$apply(function () {
                            $rootScope.redirect_app = data.redirect_app;
                        });                        
                    }
                }, 1*1000);              
            };
            var notificationReceivedCallback = function(jsonData) {
                $timeout(function(){
                    alert('notificationReceivedCallback: ' + JSON.stringify(jsonData)); 
                }, 2*1000);               
            };

            window.plugins.OneSignal
              .startInit("c725f73a-303a-4af6-892d-ab91ac4475cf", "144759231275")
              .handleNotificationOpened(notificationOpenedCallback)
              //.handleNotificationReceived(notificationReceivedCallback)
              .inFocusDisplaying(window.plugins.OneSignal.OSInFocusDisplayOption.Notification)//None, InAppAlert ou Notification.
              .endInit();
      
      
            window.plugins.OneSignal.getIds(function(ids) {
//                var i = JSON.parse(ids);
//                $rootScope.$apply(function () {
//                    localStorage.setItem('player_id_onesignal',ids.userId);
//                    $rootScope.player_id_onesignal = ids.userId;
//                });
                  localStorage.setItem('player_id_onesignal',ids.userId);
                  $rootScope.player_id_onesignal = ids.userId;
                
                //document.getElementById("OneSignalPushToken").innerHTML = "PushToken: " + ids.pushToken;
                //alert('getIds: ' + JSON.stringify(ids) + " - id: " + ids.userId);
              });

            // Sync hashed email if you have a login system or collect it.
            //   Will be used to reach the user at the most optimal time of day.
            // window.plugins.OneSignal.syncHashedEmail(userEmail);
            /****** FIM - ONSIGNAL ******/
            

            document.addEventListener("backbutton", onBackKeyDown, false); 
            
            //Pega a versão do App
            //$rootScope.version_app = $window.cordova.plugins.version.getAppVersion();
            $rootScope.version_app = navigator.appInfo.version;
        };            
        var onBackKeyDown = function(){            
            if( $('#list_gallery_freuniao').data('lightGallery') || $('#list_msgs').data('lightGallery') ){
                $(".lg-close").trigger("click");//Fecha LigthGallery
            }else if(modalOpen()){
                $('.modal').modal('hide');
            }else{
                //history.back();
                history.go(-1);
                //navigator.app.backHistory();
            }                 
        };
        
        
        

        /**
         * Verifica se tem alguma Janela Modal Bootstrap aberta
         * @returns {Boolean}
         */
        var modalOpen = function(){
            var resp = false;
            if($("#infoCelulaModal").hasClass("in") 
                    || $("#relCelModal").hasClass("in") 
                    || $("#detalhesReuniaoModal").hasClass("in")
                    || $("#sobreModal").hasClass("in") 
                    || $("#perfilModal").hasClass("in") 
                    || $("#notifModal").hasClass("in") 
                    || $("#msgModal").hasClass("in") 
                    || $("#videoModal").hasClass("in") 
                    || $("#loginModal").hasClass("in")){
                resp = true;
            }
            return resp;
        };
        /*** DEVICEREADY ***/
}]);

