app.directive('bibliaDownload', function(){
    return {
        restrict: 'EA',
        templateUrl: 'app/c/biblia/bibliaDownloadTpl.html',
        scope: {
            modo: "=",
            startDownBiblia: "=",
            startBiblia: "&"
        },
        controller: function($scope, $rootScope, bibliaService){            
            var db_biblia;
            $scope.pg_atual_vers_biblia = 0;
            $scope.biblia_cancelar_op_down_biblia_from_mysql = false;
            $scope.perc = 0;
            $scope.startDownBiblia = false;
            $scope.continuar_op = true;
            
            $scope.$watch('startDownBiblia', function(newValue){
                $rootScope.navtop.menuR = !newValue;
                $rootScope.navtop.btnBack = !newValue;
                if($rootScope.deviceready){
                    if(newValue){
                        window.plugins.insomnia.keepAwake();//Impede o dispositivo de pegar no sono
                    }else{
                        window.plugins.insomnia.allowSleepAgain();//Permite o dispositivo pegar no sono
                    }
                }                    
            });
            
            $scope.downBibliaFromMysqlServidor = function(){
                if($scope.startDownBiblia) return false;
                db_biblia = bibliaService.conex();
                $scope.pg_atual_vers_biblia = 0;
                $scope.perc = 0;
                $scope.startDownBiblia = true;
                $scope.biblia_cancelar_op_down_biblia_from_mysql = false;
                $scope.continuar_op = true;
                $scope.getSqlBibliaFromMysqlServidor();
            };

            $scope.getSqlBibliaFromMysqlServidor = function(){ 
                $.ajax({
                    type: "get",
                    url: $rootScope.rootUrl + "Biblia/getVersiculosAll/" + $scope.pg_atual_vers_biblia,
                    success: function(data){
                        if($scope.biblia_cancelar_op_down_biblia_from_mysql === true) return;

                        $scope.pg_atual_vers_biblia = $scope.pg_atual_vers_biblia+1;

                        //Barra de progresso
                        $scope.$apply(function () {
                            $scope.perc = Math.floor($scope.pg_atual_vers_biblia / data.result.max_pag * 100);
                        });                        

                        if($scope.pg_atual_vers_biblia >= data.result.max_pag){
                            $scope.continuar_op = false;                               
                        }
                        
                        db_biblia.transaction(function(tx){                    
                            data.result.dados.forEach(function(row){ 
                                tx.executeSql('INSERT INTO versiculos(ver_id, ver_vrs_id, ver_liv_id, ver_capitulo, ver_versiculo, ver_texto) VALUES ('+row.ver_id+', '+row.ver_vrs_id+', '+row.ver_liv_id+', '+row.ver_capitulo+', '+row.ver_versiculo+', "'+row.ver_texto+'")');
                            });                    
                        },function(error){
                            $scope.continuar_op = false;
                            $scope.resetDownBibliaFromMysqlServidor();
                            navigator.notification.alert("Erro ao processar o SQL: " + error.code + " - "+error.message, null, 'Erro');
                        });                

                    },
                    error: function(result){    
                        $scope.continuar_op = false;
                        $scope.cancelarOpDownBibliaFromMysqlServidor();
                        alert(result.responseText);                        
                    },
                    complete: function() {
                        if($scope.biblia_cancelar_op_down_biblia_from_mysql === false){
                            if($scope.continuar_op){
                                $scope.getSqlBibliaFromMysqlServidor();
                            }else{
                                $scope.resetDownBibliaFromMysqlServidor();
                                $scope.$apply(function () {
                                    $scope.modo = 2;
                                });                                
                            }  
                        }else{
                            $scope.continuar_op = false;
                            $scope.resetDownBibliaFromMysqlServidor();
                        }                       
                    }
                });
            };
            $scope.cancelarOpDownBibliaFromMysqlServidor = function(){    
                $scope.biblia_cancelar_op_down_biblia_from_mysql = true;
                db_biblia = null;
                $scope.resetDownBibliaFromMysqlServidor();  
                
                $scope.startBiblia();
            };
            $scope.resetDownBibliaFromMysqlServidor = function(){
                $scope.startDownBiblia = false;
                $scope.pg_atual_vers_biblia = 0;
                $scope.perc = 0;
            };
        }
    };
});

app.directive('biblia', function(){
    return {
        restrict: 'EA',
        templateUrl: 'app/c/biblia/bibliaTpl.html',
        scope: {
            origem: "@",
            startDownBiblia: "=",
            versiculoSelec: "="
        },
        link: function(scope, el, attr){
            componentHandler.upgradeAllRegistered();
        },
        controller: function($scope, $rootScope, bibliaService, biblia_velho_testamento_arr, biblia_novo_testamento_arr){
            $scope.biblia_velho_testamento_arr = biblia_velho_testamento_arr;
            $scope.biblia_novo_testamento_arr = biblia_novo_testamento_arr;
            
            var db_biblia = null;
            $scope.cap_list = [];
            $scope.versiculos_list = [];
            
            $scope.aba_testamento = 1;
            
            $scope.loader = false;
            
            $scope.modo = 0;//0-aguardando 1-download 2-biblia
            $scope.startDownBiblia = false;
            $scope.origem = '0';
            $scope.versiculoSelec = "";
            
            $scope.filtro = {};

            $scope.$watch('modo', function(newValue){
                if(newValue === 2){                    
                    $scope.initBiblia();
                }else if(newValue === 3){
                    $scope.scrollUp();
                }
                
            });
            
            $scope.init = function(){
                $scope.verifFileExistBdBiblia();
            };

            $scope.verifFileExistBdBiblia = function(){                
                if(!db_biblia){
                    $scope.startBibliaDB(false);
                }                      
            };

            $scope.startBibliaDB = function(drop){
                $scope.modo = 0;
                db_biblia = bibliaService.conex();
                
                db_biblia.transaction(function(tx){        
                    if(drop){
                        tx.executeSql('DROP TABLE IF EXISTS versiculos');
                     }
                    tx.executeSql('CREATE TABLE IF NOT EXISTS versiculos (ver_id INTEGER PRIMARY KEY NOT NULL UNIQUE , ver_vrs_id INTEGER NOT NULL , ver_liv_id INTEGER NOT NULL , ver_capitulo INTEGER NOT NULL , ver_versiculo INTEGER NOT NULL , ver_texto TEXT, ver_cor_selec VARCHAR(10) NULL, ver_fav INTEGER(1) DEFAULT 0 NOT NULL)');

                }, function(err){
                    navigator.notification.alert("Error processing SQL: " + err.code + " - "+err.message, null, 'Erro');
                }, function(){//Success
                    db_biblia.transaction(function(tx){
                        tx.executeSql('SELECT ver_id FROM versiculos WHERE ver_liv_id = 66 AND ver_capitulo = 22 AND ver_versiculo = 21',[], function(tx, result){
                            if(result.rows.length > 0){
                                $scope.$apply(function () {
                                    $scope.modo = 2;
                                }); 
                            }else{        
                                if(!drop){
                                    $scope.startBibliaDB(true);
                                }else{
                                    $scope.$apply(function () {
                                        $scope.modo = 1;
                                    }); 
                                }                    
                            }
                        }, function(error){
                            navigator.notification.alert("Erro ao processar o SQL: " + error.code + " - "+error.message, null, 'Erro');
                        });
                    },function(error){
                        navigator.notification.alert("Erro ao processar o SQL: " + error.code + " - "+error.message, null, 'Erro');
                    });                         
                });
            };
            
            $scope.getNomeLiv = function(liv){
                var nome_liv = "";
                if(liv > 39){
                    $scope.biblia_novo_testamento_arr.forEach(function(i) {
                       if(i.id == liv){
                            nome_liv = i.liv;
                       }
                    });
                }else{
                    $scope.biblia_velho_testamento_arr.forEach(function(i) {
                        if(i.id == liv){
                            nome_liv = i.liv;
                        }       
                    });
                }   
                return nome_liv;
            };

            
            $scope.initBiblia = function(){
                $scope.tam_font_vers_atual = localStorage.getItem('biblia_tam_font_versiculos_atual') ? localStorage.getItem('biblia_tam_font_versiculos_atual') : 14;
                $scope.nav_liv_atual = localStorage.getItem('biblia_liv_ultima_visita') && $scope.origem == '0' ? parseInt(localStorage.getItem('biblia_liv_ultima_visita')) : 1;
                $scope.nav_cap_atual = localStorage.getItem('biblia_cap_ultima_visita') && $scope.origem == '0' ? parseInt(localStorage.getItem('biblia_cap_ultima_visita')) : 1;
                $scope.nav_ver_id_atual = 1;
                $scope.nav_cap_inic = 1;
                $scope.nav_cap_fim = 1;
                $scope.nome_liv_selec = $scope.getNomeLiv($scope.nav_liv_atual);

                if($scope.nav_liv_atual > 39){
                    //Selecionar a aba novo testamento
                    setTimeout(function(){
                        $scope.$apply(function () {
                            $scope.aba_testamento = 2;
                        });                             
                    },300);            
                }

                $scope.getCapitulosPorLivro($scope.nav_liv_atual, $scope.nav_cap_atual);
            };
            
            $scope.scrollUp = function(){
                $('html, body').animate({scrollTop: 0},1);
                $scope.clearSelecVersiculos();
            };

            
            $scope.setLivro = function(liv){
                //$("a[href='#capitulo']").trigger("click");
                $scope.nav_liv_atual = liv;  
                $scope.cap_list = [];
                setTimeout(function(){
                    $scope.getCapitulosPorLivro(liv);
                    show_aba("capitulo");
                    $scope.scrollUp();
                    if($scope.origem == '0') localStorage.setItem('biblia_liv_ultima_visita',liv);
                },100);
            };
            $scope.setCapitulo = function(liv,cap){
                //$("a[href='#versiculo']").trigger("click");
                $scope.nav_cap_atual = cap;      
                $scope.versiculos_list = [];
                setTimeout(function(){
                    $scope.getVersiculosPorLivroCapitulo(liv,cap);
                    show_aba("versiculo");
                    $scope.scrollUp();
                    if($scope.origem == '0') localStorage.setItem('biblia_cap_ultima_visita',cap);
                },100);                    
            };
            $scope.setVersiculo = function(i){
                if($scope.origem == 1){
                    var nome_livro = $scope.getNomeLiv(i.ver_liv_id);
                    $scope.versiculoSelec = nome_livro+' '+i.ver_capitulo+':'+i.ver_versiculo+' - "'+i.ver_texto+'"';
                }else{
                    $scope.setVersiculoEdit(i.ver_id);
                }                    
            };
            
            
            $scope.getCapitulosPorLivro = function(liv,_cap){
                $scope.nav_liv_atual = liv;
                $scope.nav_cap_atual = _cap ? _cap : '1';
                $scope.nome_liv_selec = $scope.getNomeLiv(liv);
                $scope.cap_list = [];
                
                db_biblia.transaction(function(tx){
                      tx.executeSql('SELECT ver_capitulo FROM versiculos WHERE ver_liv_id = '+liv+' GROUP BY ver_capitulo ORDER BY ver_capitulo ASC ',[], function(tx, result){
                            
                            if (result !== null && result.rows !== null) {    
                                var row;
                                var arr = [];
                                for (var i = 0; i < result.rows.length; i++) {
                                    row = result.rows.item(i);
                                    arr.push(row);                                                                           
                                }
                                $scope.$apply(function () {
                                    $scope.cap_list = arr;
                                }); 
                            }       
                            $scope.$apply(function () {
                                $scope.nav_cap_fim = result.rows.length;
                            });
                            
                            var cap = _cap ? _cap : 1;
                            setTimeout(function(){
                                $scope.getVersiculosPorLivroCapitulo(liv,cap);
                            },1*100);                            
                      }, bibliaService.errorCB);
                  },bibliaService.errorCB);
            };
            
            $scope.getVersiculosPorLivroCapitulo = function(liv,cap){
                $scope.nav_cap_atual = cap;
                $scope.versiculos_list = [];
                
                db_biblia.transaction(function(tx){
                    tx.executeSql('SELECT * FROM versiculos WHERE ver_liv_id = '+liv+' AND ver_capitulo = '+cap+' ORDER BY ver_versiculo ASC',[], function(tx, result){
                        
                        if (result !== null && result.rows !== null) {
                            var row;
                            var arr = [];
                            for (var i = 0; i < result.rows.length; i++) {
                                row = result.rows.item(i);
                                arr.push(row);                               
                            }
                            $scope.$apply(function () {
                                $scope.versiculos_list = arr;
                            }); 
                        }
                        $(".list_versiculos").css('font-size', $scope.tam_font_vers_atual+'px');
                    }, bibliaService.errorCB);
                  },bibliaService.errorCB);
            };
            
            
            $scope.setAntCap = function(){
                var liv = $scope.nav_liv_atual;
                var cap = $scope.nav_cap_atual - 1;
                $scope.nav_cap_atual = cap;
                cap = cap < 1 ? 1 : cap;
                $('html, body').animate({scrollTop: 0});

                $scope.setCapitulo(liv,cap);
            };
            $scope.setProxCap = function(){
                var liv = $scope.nav_liv_atual;
                var cap = $scope.nav_cap_atual + 1;
                $scope.nav_cap_atual = cap;
                cap = cap > $scope.nav_cap_atual ? $scope.nav_cap_atual : cap;
                $('html, body').animate({scrollTop: 0});

                $scope.setCapitulo(liv,cap);
            };

            $scope.setMenosFontSizeVersiculosBiblia = function(){
                var tam_atual = $scope.tam_font_vers_atual;
                var tam = tam_atual <= 14 ? 14 : (parseInt(tam_atual) - 4);    
                $scope.tam_font_vers_atual = tam;
                localStorage.setItem('biblia_tam_font_versiculos_atual',tam);
                $(".list_versiculos").css('font-size',tam+'px');
            };
            $scope.setMaisFontSizeVersiculosBiblia = function(){
                var tam_atual = $scope.tam_font_vers_atual;
                var tam = tam_atual >= 26 ? 26 : (parseInt(tam_atual) + 4);    
                $scope.tam_font_vers_atual = tam;
                localStorage.setItem('biblia_tam_font_versiculos_atual',tam);
                $(".list_versiculos").css('font-size',tam+'px');
            };
            
            
            //PESQUISA =============================================================
            
            $scope.popularSelecLivros = function(t){
                $scope.livros_arr = t === 1 ? $scope.biblia_velho_testamento_arr : $scope.biblia_novo_testamento_arr; 
            };
            
            /**
             * Pesquisar versículos da bíblia
             * @param {type} orig
             * @returns {undefined}
             */
            $scope.getVersiculosPorPesquisa = function(){

                var sql = 'SELECT * FROM versiculos WHERE ';

                if($scope.filtro.fav){
                    sql += 'ver_fav = 1 AND ';
                }

                if($scope.filtro.testamento === 1){
                    sql += "ver_liv_id <= 39 AND ";
                }else if($scope.filtro.testamento === 2){
                    sql += "ver_liv_id >= 40 AND ";
                }
                if($scope.filtro.livro){
                    sql += "ver_liv_id = "+$scope.filtro.livro;
                }        

                var arr_p = [];
                var num = 0;
                var i = 0;
                if($scope.filtro.palav){
                    sql +=  ' AND (';  
                    arr_p = $scope.filtro.palav.split(' ');
                    num = arr_p.length;
                    for(i=0;i<num;i++)
                    {
                        sql += " lower(ver_texto) LIKE lower('%"+arr_p[i]+"%') ";
                        if(i !== (num-1)){sql += ' AND ';}
                    }        
                    sql +=  ') ';
                }
                sql += " ORDER BY ver_id ASC LIMIT 100";
                
                $scope.loader = true;

                db_biblia.transaction(function(tx){
                    tx.executeSql(sql,[], function(tx, result){
                        $scope.pesq_list = [];
                        
                        if (result !== null && result.rows !== null) {   
                            var row;
                            var arr = [];
                            for (var i = 0; i < result.rows.length; i++) {
                                row = result.rows.item(i);
                                arr.push(row);                            
                            }
                            $scope.$apply(function(){
                                $scope.pesq_list = arr;
                            }); 
                            $(".list_versiculos").css('font-size', $scope.tam_font_vers_atual+'px');
                        }
                        $scope.$apply(function(){
                            $scope.loader = false;
                        });
                        
                    }, bibliaService.errorCB);
                  },bibliaService.errorCB);
            };
            
            $scope.closePesquisa = function(){
                $scope.modo = 2;
                $scope.pesq_list = [];
                $scope.filtro = {};
            };
            $scope.goVersiculoBiblia = function(i){
                if($scope.origem == '1'){
                    $scope.setVersiculo(i);
                }else{                    
                    $scope.scrollUp();
                    $scope.nav_liv_atual = i.ver_liv_id;
                    $scope.nav_cap_atual = i.ver_capitulo;
                    $scope.nav_ver_id_atual = i.ver_id;
                    
                    localStorage.setItem('biblia_liv_ultima_visita', i.ver_liv_id);
                    localStorage.setItem('biblia_cap_ultima_visita', i.ver_capitulo);
                    
                    if(i.ver_liv_id > 39){
                        //$("a[href='#aba_liv_novo']").trigger("click");
                        $scope.aba_testamento = 2;
                    }else{
                        $scope.aba_testamento = 1;
                    }    
                    
                    show_aba("versiculo");
                    
                    $scope.closePesquisa();

                    setTimeout(function(){
                        var vers = $("#ver_"+i.ver_id);
                        $("html body").animate({scrollTop: vers.offset().top - 193}, 2000, function(){
                            vers.animate({opacity:'toggle'}).animate({opacity:'toggle'});
                        });
                    },1*1000);
                }                    
                     
            };
            
            var show_aba = function(aba){
                if(aba !== "livro") hide_aba("livro");
                if(aba !== "capitulo") hide_aba("capitulo");
                if(aba !== "versiculo") hide_aba("versiculo");
                
                angular.element('#'+aba).addClass('is-active');
                angular.element('a[href="#'+aba+'"]').addClass('is-active');
            };
            var hide_aba = function(aba){
                angular.element('#'+aba).removeClass('is-active');
                angular.element('a[href="#'+aba+'"]').removeClass('is-active');
            };
            
            
            /******************  BOX SELEC VERSÍCULOS *********************/
            $scope.setVersiculoEdit = function(ver_id){
                angular.element('#ver_'+ver_id).toggleClass('selec_click_vers_biblia');
                $scope.upDownBoxCtrlSelecVersiculo();  
            };

            $scope.clearSelecVersiculos = function(){
                $('#list_biblia > p').removeClass('selec_click_vers_biblia');
                $scope.upDownBoxCtrlSelecVersiculo();
            };
            $scope.upDownBoxCtrlSelecVersiculo = function(){
                if($('#list_biblia > p.selec_click_vers_biblia').length > 0){
                    $('#box_ctrl_selec_versiculo').slideDown('slow');
                    $('#box_biblia_topo_versiculos').slideUp('slow');
                }else{
                    $('#box_ctrl_selec_versiculo').slideUp('slow');
                    $('#box_biblia_topo_versiculos').slideDown('slow');
                }
            };

            $scope.setCorSelecVersiculos = function(cor){
                var selec = $('#list_biblia > p.selec_click_vers_biblia');
                cor = (cor !== 'remove_cor') ? cor : null;   
                selec.each(function(i,v){
                    if($(this).hasClass('marqVersFavorito')){
                        $(this).removeClass().addClass('marqVersFavorito');
                    }else{
                        $(this).removeClass();
                    }
                    $(this).addClass('btnCoresVers-'+cor);
                    var ver_id = $(this).find('.ver_id').html();
                    $scope.salvarCorSelecVersiculoBiblia(ver_id, cor);            
                });  
            };
            $scope.salvarCorSelecVersiculoBiblia = function(ver_id,ver_cor_selec){
                db_biblia.transaction(function(tx){
                    tx.executeSql('UPDATE versiculos SET ver_cor_selec = "'+ver_cor_selec+'" WHERE ver_id = '+ver_id,[], function(tx, result){
                        $scope.clearSelecVersiculos();
                    }, bibliaService.errorCB);
                  },bibliaService.errorCB);                    
            };

            $scope.setFavoritoSelecVersiculos = function(){
                var selec = $('#list_biblia > p.selec_click_vers_biblia');
                var fav_selec = 0;
                var fav_unselec = 0;

                selec.each(function(i,v){
                    var ver_id = $(this).find('.ver_id').html();        

                    if($(this).hasClass("marqVersFavorito")){
                        $scope.salvarFavoritoSelecVersiculoBiblia(ver_id,0);     
                        $(this).removeClass('marqVersFavorito');
                        fav_unselec++;
                    }else{
                        $scope.salvarFavoritoSelecVersiculoBiblia(ver_id,1);     
                        $(this).addClass('marqVersFavorito');
                        fav_selec++;
                    }
                });    

                $scope.clearSelecVersiculos();

                var txt = fav_selec > 0 ? fav_selec+' adicionado(s)' : "";
                var e_txt = (fav_selec > 0 && fav_unselec > 0) ? " e " : "";
                txt = txt+e_txt;
                txt += fav_unselec > 0 ? fav_unselec+' removido(s)' : "";

                if($rootScope.deviceready){
                    window.plugins.toast.showLongBottom(txt+' dos favoritos');
                }                    
            };
            $scope.salvarFavoritoSelecVersiculoBiblia = function(ver_id, ver_fav){
                db_biblia.transaction(function(tx){
                    tx.executeSql('UPDATE versiculos SET ver_fav = '+ver_fav+' WHERE ver_id = '+ver_id,[], function(tx, result){
                        //OK
                    }, bibliaService.errorCB);
                  },bibliaService.errorCB);
            };

            $scope.sendVersSelecSocialSharing = function(){
                var selec = $('#list_biblia > p.selec_click_vers_biblia');
                var vers_0 = '';
                var vers_1 = '';
                var vers = '';

                selec.each(function(i,v){
                    vers_0 = $(this).find('strong').html();
                    vers_1 = $(this).find('.vers_txt').html();
                    vers += $scope.getNomeLiv($scope.nav_liv_atual) + ": " + $scope.nav_cap_atual + '.' + vers_0 + '. ' + vers_1 + ' ';
                });
                if(vers){
                    if($rootScope.deviceready){
                        window.plugins.socialsharing.share(vers);
                    }else{
                        alert(vers);
                    }                        
                }    
            };

            /**
             * Start
             */
            $scope.init();
        }
    };
});


