app.controller('dispIdentIgController', ['$scope', 
                                        '$rootScope', 
                                        '$location', 
                                        '$timeout',
                                        'dispIdentIgService',
                                        'dispAtivarService',
                                        'loginService',
                                        'uf_arr', 
                                        'Util', 
                                        'geo', function ($scope, $rootScope, $location, $timeout, dispIdentIgService, dispAtivarService, loginService, uf_arr, Util, geo) {
        $rootScope.navtop.vis = false;
        $rootScope.navtop.transp = false;

        $scope.uf_arr = uf_arr;
        $scope.disp = {};
        $scope.igrs = [];
        $scope.loader = false;
        $scope.loader_geo = false;
        
        $scope.init = function(){
            startGetUfDisp();
        };

        $scope.submitFocus = function () {
            angular.element(':submit').focus();
        };
        
        /**
         * GeoLocalização da UF onde o dispositivo está localizado
         * @returns {undefined}
         */
        var startGetUfDisp = function(){    
            if($rootScope.APP_INDIVIDUAL) return false;
            $scope.loader_geo = true;
            
            geo.geoLocalizEnderecoDispositivo(function(addr){
                if(!$scope.disp.ig_uf && addr){
                    $scope.disp.ig_uf = addr.uf_short_name; 
                    $scope.$apply();
                    $scope.getCidadesComIgrejasPorUfAll();
                } 
                $scope.loader_geo = false;
            });
            
            $timeout(function(){
                $scope.loader_geo = false;
            }, 5000);
        };        

        /**
         * Retorna as cidades por uf das igrejas ativas no sistema
         * @returns {undefined}
         */
        $scope.getCidadesComIgrejasPorUfAll = function () {
            $scope.loader = true;
            $scope.cidades_por_uf = [];
            $scope.igrs = [];

            dispIdentIgService.getCidadesComIgrejasPorUfAll($scope.disp.ig_uf).success(function (data) {
                $scope.cidades_por_uf = data.result;

                $scope.loader = false;
            }).error(function (data, status, headers, config) {
                Util.alertErrorMessage(data, status);
                $scope.loader = false;
                if(status==0){
                    $scope.disp.ig_uf = null;
                }
            });
        };

        /**
         * Retorna as igrejas pela cidade selecionada
         * @returns {undefined}
         */
        $scope.getIgrejasPorLocalidade = function(_ig_cidade){
            $('html, body').animate({scrollTop: 0});
            $scope.disp.ig_cidade = _ig_cidade;
            $scope.igrs = [];
            $scope.loader = true;            
            
            dispIdentIgService.getIgrejasPorLocalidade('55', $scope.disp.ig_uf, $scope.disp.ig_cidade).success(function(data){
                $scope.igrs = data.result;
                
                $scope.loader = false;
            }).error(function (data, status, headers, config){
                Util.alertErrorMessage(data, status);
                $scope.loader = false;
            });
        }; 
        
        $scope.ativarDispServ = function (ig_cod, ig_nome) {
            $scope.loader = true;

            dispAtivarService.ativarDisp(ig_cod).success(function (data) {
                $scope.setIdentificIgreja(ig_cod, ig_nome);                
                $scope.loader = false;
            }).error(function (data, status, headers, config) {
                Util.alertErrorMessage(data, status);
                $scope.loader = false;
            });
        };
        
        $scope.desativarDispServ = function () {
            $scope.loader = true;

            var tk = localStorage.getItem('lg_token_session') ? true : false;
            if(tk) loginService.setLogout(true);
            
            dispAtivarService.desativarDisp().success(function (data) {
                dispIdentIgService.removeIdentificIgreja(); 
                $scope.loader = false;
            }).error(function (data, status, headers, config) {
                Util.alertErrorMessage(data, status);
                $scope.loader = false;
            });
        };
        
        /**
         * Setar identificação da igreja selecionada pelo usuário do app
         * @returns {undefined}
         */
        $scope.setIdentificIgreja = function(ig_cod, ig_nome){
            $scope.disp.ig_cod = ig_cod;
            $scope.disp.ig_nome = ig_nome;

            var ig_atual = localStorage.getItem('ig_cod') ? localStorage.getItem('ig_cod') : null;

            dispIdentIgService.setLocalStorageIdentificIgreja($scope.disp);

            if($rootScope.deviceready){
                window.plugins.toast.showLongBottom('Igreja: '+$scope.disp.ig_cod+' - '+$scope.disp.ig_nome);
            }else{
                //
            }          
            
            localStorage.setItem('tagPadraoDefinidaNoServPush','OK');

            if(ig_atual != $scope.disp.ig_cod && ig_atual !== null){
                loginService.setLogout();
            }else{
                $location.path('/');
            } 
        };
        
        
        
        
        
        /**
         * Start
         */
        $scope.init();

}]);


