app.service('dispIdentIgService', ['$rootScope', 'http', 'loginService', function($rootScope, http, loginService){
    
    this.getDadosStart = function(){
        var url = $rootScope.rootUrl+"Igreja/getDadosStart";
        var params = {
            ins_cod: $rootScope.APP_INS_COD, 
            ig_cod: $rootScope.dispIg.ig_cod, 
            us_cod_logado: $rootScope.lg.us_cod,
            lg: loginService.getLgSession()
        };
        
        return http.post(url, params);
    };
    
    /**
     * Retorna as cidades por uf das igrejas ativas no sistema
     * @param {type} uf
     * @returns {unresolved}
     */
    this.getCidadesComIgrejasPorUfAll = function(uf){
        var url = $rootScope.rootUrl+"Igreja/getCidadesPorUfIgrejas";
        var params = {ins_cod: $rootScope.APP_INS_COD, uf: uf};
        
        return http.post(url, params);
    };
    
    /**
     * Retorna as igrejas pela cidade selecionada
     * @param {string} _pais
     * @param {string} _uf
     * @param {string} _cidade
     * @returns {unresolved}
     */
    this.getIgrejasPorLocalidade = function(_pais, _uf, _cidade){
        var url = $rootScope.rootUrl+"Igreja/getIgrejasPorLocalidade";
        var params = {ins_cod: $rootScope.APP_INS_COD, pais: _pais, uf: _uf, cidade: _cidade};
        
        return http.post(url, params);
    };
    
    /**
     * Seta os dados da igreja selecionada pelo usuário do app
     * @param {object} disp
     * @returns {undefined}
     */
    this.setLocalStorageIdentificIgreja = function(disp){
        localStorage.setItem('disp_ig_cod',disp.ig_cod);
        localStorage.setItem('disp_ig_nome',disp.ig_nome);
        localStorage.setItem('disp_ig_cidade',disp.ig_cidade);
        localStorage.setItem('disp_ig_uf',disp.ig_uf);
        this.setDispIgRoot();
    };
    
    /**
     * Setar dados da igreja selecionada de forma global ($rootScore)
     * @returns {undefined}
     */
    this.setDispIgRoot = function(){     
        $rootScope.dispIg.ig_cod = localStorage.getItem('disp_ig_cod');
        $rootScope.dispIg.ig_nome = localStorage.getItem('disp_ig_nome');
        $rootScope.dispIg.ig_cidade = localStorage.getItem('disp_ig_cidade');
        $rootScope.dispIg.ig_uf = localStorage.getItem('disp_ig_uf');
    };
    
    this.removeIdentificIgreja = function(){
        localStorage.removeItem('disp_ig_cod');
        localStorage.removeItem('disp_ig_nome');
        localStorage.removeItem('disp_ig_cidade');
        localStorage.removeItem('disp_ig_uf');
        
        $rootScope.dispIg.ig_cod = null;
        $rootScope.dispIg.ig_nome = null;
        $rootScope.dispIg.ig_cidade = null;
        $rootScope.dispIg.ig_uf = null;

        window.plugins.toast.showLongTop('A identificação da igreja foi removida!');
    };
}]);

