app.controller('downController', ['$scope', '$rootScope', '$window', 'loginService', 'bdAppService', function($scope, $rootScope,$window, loginService, bdAppService){
    $rootScope.navtop.btnBack = true;    
    $rootScope.navtop.title = "Downloads";
        
    $scope.dw_list = [];
    $scope.get_list_down = 0;
    $scope.modo = 0;
    
    $scope.search_modo = false;
    $scope.search_down = "";
    
    var db_app = null;
    
    $scope.$watch('startDownFile', function(newValue){
        $rootScope.navtop.menuR = !newValue;
        $rootScope.navtop.btnBack = !newValue;
        if($rootScope.deviceready){
            if(newValue){
                $window.plugins.insomnia.keepAwake();//Impede o dispositivo de pegar no sono
            }else{
                $window.plugins.insomnia.allowSleepAgain();//Permite o dispositivo pegar no sono
            }
        }                    
    });

    $scope.init = function(){
        db_app = bdAppService.conex();
        $scope.getListDownloadPendenteAll(true);//Local
        $scope.startDownFile = false;
        $scope.loader = false;  
        $scope.scrollUp();
    };
    
    
    
    $scope.scrollUp = function(){
        $('html, body').animate({scrollTop: 0},1);
    };

    $scope.getUltDownloads = function(filtPesq, notif){
        if(filtPesq){
            $scope.dw_list = [];
        }

        var params = JSON.stringify({
            lg: loginService.getLgSession(),
            ig_cod: localStorage.getItem('disp_ig_cod')
        });

        $.ajax({
            type: "post",
            url: $rootScope.rootUrl + "Download/getUltDownloads",
            data: params,
            dataType: "json",
            success: function(data){

                if(data.result === "logout"){setLogout(); return false;}

                data.result.forEach(function(item){
                    $scope.insertDownloadBdLocal(item, notif);
                });
            },error: function(result){
                //alert(result.responseText);
                //alertErrorMessage(result.responseText,null,'#dw_list',$scope.getUltDownloads,f_start);
            },complete: function(){
                //$.mobile.loading('hide');
            }
        });
    };

    $scope.setCountDown = function(arq){   
        var params = JSON.stringify({
            dw_arq: arq
        });

        $.ajax({
            type: "post",
            url: $rootScope.rootUrl + "Download/setCountDown",
            data: params,
            dataType: "json",
            success: function(data){
                //OK
            },error: function(result){
                //alertErrorMessage(result.responseText,null,'#dw_list',$scope.getUltDownloads,f_start);
            },complete: function(){
                //$.mobile.loading('hide');
            }
        });
    };

    var errorDB = function(error) {
        $scope.loader = false;
        alert("Erro ao processar o SQL: " + error.code + " - "+error.message, null, 'Erro');
        //navigator.notification.alert("Erro ao processar o SQL: " + error.code + " - "+error.message, null, 'Erro');
    };

    $scope.insertDownloadBdLocal = function(item, notif){        
        $scope.loader = true;
        db_app.transaction(function(tx){
            tx.executeSql('SELECT dw_cod FROM download WHERE dw_arq = "'+item.dw_arq+'" LIMIT 1',[], function(tx, result){
                if(result.rows.length === 0){  
                    db_app.transaction(function(tx){
                        tx.executeSql('INSERT INTO download (dw_nome, dw_arq, dw_ok, dw_datacreate) VALUES ("'+item.dw_nome+'", "'+item.dw_arq+'", 0, "'+item.dw_datacreate+'")',[], function(tx, result){
                            $scope.$apply(function () {
                                $scope.dw_list.push(item);
                            });                                
                        });
                    },errorDB);
                }
                $scope.$apply(function(){
                    $scope.loader = false;
                });                    
            });
        },errorDB);
    };

    $scope.getListDownload = function(){    
        if($scope.get_list_down === 0){
            $scope.getListDownloadPendenteAll();
        }else if($scope.get_list_down === 1){
            $scope.getListDownloadBaixadosAll();
        }else{
            $scope.getListDownloadLixeiraAll();
        }
    };

    
    $scope.getListDownloadPendenteAll = function(start){  
        if($scope.loader) return false;
        $scope.scrollUp();

        $scope.get_list_down = 0;
        $scope.loader = true;

        $scope.dw_list = [];
        db_app.transaction(function(tx){
            var wh = "";
            if($scope.search_down){
                wh = 'AND lower(dw_nome) LIKE lower("%'+$scope.search_down+'%")';
            }
            
            tx.executeSql('SELECT * FROM download WHERE dw_ok = 0 AND dw_lix = 0 '+wh+' ORDER BY dw_datacreate DESC LIMIT 100',[], function(tx, result){

                if(result.rows.length > 0){
                    var row;
                    var arr = [];
                    for (var i = 0; i < result.rows.length; i++) {
                        row = result.rows.item(i);
                        arr.push(row);
                    }
                    $scope.$apply(function () {
                        $scope.dw_list = arr;
                    }); 
                }
                $scope.$apply(function () {
                    $scope.loader = false;
                });
                
                if(start) $scope.getUltDownloads();//Verifica no servidor 
            }, errorDB);
        },errorDB);
    };
    $scope.getListDownloadBaixadosAll = function(){
        if($scope.loader) return false;
        $scope.scrollUp();

        $scope.get_list_down = 1;
        $scope.loader = true;

        $scope.dw_baixados_list = [];
        db_app.transaction(function(tx){
            var wh = "";
            if($scope.search_down){
                wh = 'AND lower(dw_nome) LIKE lower("%'+$scope.search_down+'%")';
            }
            tx.executeSql('SELECT * FROM download WHERE dw_ok = 1 AND dw_lix = 0 '+wh+' ORDER BY dw_datacreate DESC LIMIT 120',[], function(tx, result){
                if(result.rows.length > 0){                
                    var row;
                    var arr = [];
                    for (var i = 0; i < result.rows.length; i++) {
                        row = result.rows.item(i);
                        arr.push(row);
                    }
                    $scope.$apply(function () {
                        $scope.dw_baixados_list = arr;
                    }); 
                }
                $scope.$apply(function () {
                    $scope.loader = false;
                });
            }, errorDB);
        },errorDB);
    };
    $scope.getListDownloadLixeiraAll = function(){
        if($scope.loader) return false;
        $scope.scrollUp();

        $scope.get_list_down = 2;
        $scope.loader = true;
        $scope.dw_lix_list = [];

        db_app.transaction(function(tx){
            var wh = "";
            if($scope.search_down){
                wh = 'AND lower(dw_nome) LIKE lower("%'+$scope.search_down+'%")';
            }
            tx.executeSql('SELECT * FROM download WHERE dw_lix = 1 '+wh+' ORDER BY dw_datacreate DESC LIMIT 120',[], function(tx, result){
                if(result.rows.length > 0){                
                    var row;
                    var arr = [];
                    for (var i = 0; i < result.rows.length; i++) {
                        row = result.rows.item(i);
                        arr.push(row);
                    }
                    $scope.$apply(function () {
                        $scope.dw_lix_list = arr;
                    });                        
                }
                $scope.$apply(function () {
                    $scope.loader = false;
                });
            }, errorDB);
        },errorDB);
    };

    $scope.setDownOkBd = function(_dw_arq){
        db_app.transaction(function(tx){
            tx.executeSql('UPDATE download SET dw_ok = 1, dw_lix = 0 WHERE dw_arq="'+_dw_arq+'" ',[], function(tx, result){
               //$window.plugins.toast.showShortBottom('Operação realizada com sucesso!');   
               $scope.$apply(function () {
                   $scope.loader = false;
               });                
            }, errorDB);
        },errorDB);

        $scope.getListDownload();
    };    

    $scope.confirmDeleteItemLixeiraDownBd = function(_dw_arq){
        navigator.notification.confirm(
            'Confirmar exclusão do arquivo? Esta operação não poderá ser desfeita!',
             function(buttonIndex){
                 if(buttonIndex === 1){
                     $scope.deleteItemLixeiraDownBd(_dw_arq);
                 }
             },
            'Confirmar Operação',//titulo
            ['Confirmar','Cancelar']//buttonLabels
        );
    };
    $scope.deleteItemLixeiraDownBd = function(_arq){
        db_app.transaction(function(tx){
            tx.executeSql('UPDATE download SET dw_lix = 100 WHERE dw_arq="'+_arq+'" ',[], function(tx, result){
                $scope.$apply(function () {
                   $scope.loader = false;
                }); 
                $scope.getListDownloadLixeiraAll();
                $window.plugins.toast.showShortCenter('O registro do arquivo foi excluido com sucesso!');
             }, errorDB);
         },errorDB);
    };
    $scope.esvaziarLixeiraDownBd = function(){
        db_app.transaction(function(tx){
            tx.executeSql('UPDATE download SET dw_lix = 100 WHERE dw_lix=1 ',[], function(tx, result){
                $scope.$apply(function () {
                   $scope.loader = false;
                }); 
                $scope.getListDownloadLixeiraAll();
                $window.plugins.toast.showShortCenter('A lixeira foi esvaziada com sucesso!');
             }, errorDB);
         },errorDB);
    };

    $scope.confirmDeleteDownBd = function(_dw_arq){
        navigator.notification.confirm(
            'Deseja excluir o arquivo do seu dispositivo liberando assim espaço na memória? Você ainda poderá recupera-lo na lixeira!',
             function(buttonIndex){
                 if(buttonIndex === 1){
                     $scope.deleteDownBd(_dw_arq);
                 }
             },
            'Confirmar Operação',//titulo
            ['Confirmar','Cancelar']//buttonLabels
        );
    };
    $scope.deleteDownBd = function(_arq){
        var path_arq = $rootScope.APP_NOME + "/down/" + _arq;
        var fsSuccess = function (fs) {        
            fs.root.getFile(path_arq, {create: false}, function(fileEntry){
                fileEntry.remove(function() {
                    $scope.addLixeiraDownBd(_arq);
                    $window.plugins.toast.showShortCenter('O arquivo foi excluido com sucesso do seu dispositivo!');                  
                }, function(error){
                    var msg = 'file system error: ' + error.code;
                    navigator.notification.alert(msg, null, 'File System Error');
                });
            },function(error){
                $scope.addLixeiraDownBd(_arq); 
                $window.plugins.toast.showShortCenter('O arquivo foi excluido com sucesso do seu dispositivo!'); 
            });
        };
        var fsFail = function(error) {
            alert("failed with error code: " + error.code);
        };

        $window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, fsSuccess, fsFail);

    };
    $scope.addLixeiraDownBd = function(_dw_arq){
        $scope.loader = true;
        db_app.transaction(function(tx){
            tx.executeSql('UPDATE download SET dw_lix = 1 WHERE dw_arq="'+_dw_arq+'" ',[], function(tx, result){
               //$window.plugins.toast.showShortBottom('Operação realizada com sucesso!');
               $scope.$apply(function () {
                   $scope.loader = false;
               }); 
               if($scope.get_list_down === 0){
                    $scope.getListDownloadPendenteAll();
               }else{
                    $scope.getListDownloadBaixadosAll();
               }
            }, errorDB);
        },errorDB);
    };


    $scope.sendItemDownloadSocialSharing = function(dw_nome, _arq){
        var pathlocal_arq = $rootScope.APP_NOME + "/down/" + _arq;
        var fsSuccess = function (fs) {
            var sPath = fs.root.toURI();

            fs.root.getFile(pathlocal_arq, null, function(fileEntry){
                var titulo = dw_nome;
                var msg = "Arquivo em anexo ou baixe em: "+$rootScope.rootUrl+"down.php?q="+_arq;
                $window.plugins.socialsharing.share(msg, titulo, fileEntry.toURI());  
            },function(error){
                navigator.notification.alert('Arquivo não localizado no seu dispositivo! Baixe o arquivo antes de compartilhar.', null, 'Operação cancelada');         
            });
        };
        var fsFail = function(error) {
            alert("failed with error code: " + error.code);
        };

        $window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, fsSuccess, fsFail);        
    };



    ////////////// DOWNLOAD ///////////////////
    $scope.down = {path: "", arq: ""};
    $scope.verifFileExistNoDispositivo = function(_arq){  
        var pathlocal_arq = $rootScope.APP_NOME + "/down/" + _arq;
        var fsSuccess = function (fs) {
            $scope.down.path = fs.root.toURI();
            $scope.down.arq = _arq;

            fs.root.getFile(pathlocal_arq, null, function(fileEntry){
                //alert("arquivo localizado no dispositivo: " + fileEntry.toURI());                    
                if($scope.get_list_down === 0){
                    $scope.setDownOkBd(_arq);
                }else if($scope.get_list_down === 1){
                    //OK
                }else{
                    $scope.setDownOkBd(_arq);
                }
                //Abrir arquivo
                $window.open(fileEntry.toURI(), "_system");
            },function(error){
                $scope.$apply(function () {
                    if($scope.get_list_down === 0){
                        //OK
                    }else if($scope.get_list_down === 1){
                        $scope.desmarqOkDownBd(_arq);
                    }else{
                        //OK
                    }
                    $scope.modo = 1;
                    $scope.scrollUp();
                });                               
            });
        };
        var fsFail = function(error) {
            alert("failed with error code: " + error.code);
        };

        $window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, fsSuccess, fsFail);
    };

    $scope.desmarkOkSeFileNaoExistNoDispositivo = function(_arq){  
        _arq = $rootScope.APP_NOME + "/down/" + _arq;
        var fsSuccess = function (fs) {
            var sPath = fs.root.toURI();

            fs.root.getFile(_arq, null, function(fileEntry){
                //
            },function(error){
                $scope.desmarqOkDownBd(_arq);          
            });
        };
        var fsFail = function(error) {
            alert("failed with error code: " + error.code);
        };

        $window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, fsSuccess, fsFail);
    };
    $scope.desmarqOkDownBd = function(_dw_arq){
        $scope.loader = true;
        db_app.transaction(function(tx){
            tx.executeSql('UPDATE download SET dw_ok = 0 WHERE dw_arq="'+_dw_arq+'" ',[], function(tx, result){
               //$window.plugins.toast.showShortBottom('Operação realizada com sucesso!');  
               $scope.$apply(function () {
                   $scope.loader = false;
               }); 
            }, errorDB);
        },errorDB);
        $scope.getListDownload();
    };

    $scope.downFile = function(){
        if($scope.startDownFile) return false;
        $scope.startDownFile = true;

        angular.element("#popupDownload #download_btn_group").hide();
        angular.element("#popupDownload #download_btn_abort").show();

        var sPath = $scope.down.path;
        var arq = $scope.down.arq;
        var fileServUri = encodeURI($rootScope.rootUrl+"down/"+arq);

        var ft = new FileTransfer();

        ft.onprogress = function(progressEvent) {
            if (progressEvent.lengthComputable) {
                var perc = Math.floor(progressEvent.loaded / progressEvent.total * 100);
                angular.element("#popupDownload #download_progress").val(perc);  
                angular.element("#popupDownload #download_progress_perc").html(perc+'%');

                if(angular.element("#popupDownload #download_btn_group").is(':visible')){
                    ft.abort();
                    $scope.startDownFile = false;
                }
            } else {

            }
        };

        ft.download(
                fileServUri,
                sPath + $rootScope.APP_NOME + "/down/" + arq,
                function(file){
                    $scope.$apply(function () {
                        $scope.modo = 0;
                    });  
                    ft = null;
                    $scope.resetDownFile();
                    $scope.startDownFile = false;
                    $scope.setDownOkBd(arq);
                    $scope.setCountDown(arq);

                    if($scope.get_list_down < 2){
                        //Abrir arquivo
                        var path = sPath + $rootScope.APP_NOME + "/down/" + arq;
                        $window.open(path, "_system");
                    }                    
                },
                function(error){
                    var erro_txt = "";
                    if(error.code === FileTransferError.FILE_NOT_FOUND_ERR){
                        erro_txt = "arquivo não encontrado";
                    }else if(error.code === FileTransferError.INVALID_URL_ERR){
                        erro_txt = "URL inválida";
                    }else if(error.code === FileTransferError.CONNECTION_ERR){
                        erro_txt = "Erro de conexão. Verifique sua internet.";
                    }else if(error.code === FileTransferError.ABORT_ERR){
                        //erro_txt = "Operação abortada";
                    }
                    $scope.startDownFile = false;
                    $scope.resetDownFile();
                    if(erro_txt.length > 0){alert(erro_txt + ' - Erro nº: ' + error.code);}
                    ft = null;
                },
                false,
                {
                    headers: {
                        //"Authorization": "Basic dGVzdHVzZXJuYW1lOnRlc3RwYXNzd29yZA=="
                        Connection: "close"
                    }
                }
        );
    };
    $scope.resetDownFile = function(){
        angular.element("#popupDownload #download_btn_group").show();
        angular.element("#popupDownload #download_btn_abort").hide();
        angular.element("#popupDownload #download_progress").val(0);
        angular.element("#popupDownload #download_progress_perc").html('0%');
    };
    /***************** FIM - DOWNLOAD */
    
    /**
     * Start
     */
    $scope.init();
}]);


