app.controller('freuniaoController', ['$scope', '$rootScope', '$location', 'Util', 'rede_celulas_arr', 'freuniaoService', 'redecelService', function ($scope, $rootScope, $location, Util, rede_celulas_arr, freuniaoService, redecelService) {
        $rootScope.navtop.btnBack = true;
        $rootScope.navtop.title = "Fotos das Reuniões";

        $scope.rede_celulas_arr = rede_celulas_arr;

        $scope.loader = false;
        $scope.paginacao_stop = false;
        $scope.pg = 0;
        
        $scope.search_modo = false;
        $scope.search = "";

        $scope.fr = [];
        $scope.info_ce_s = {};
        $scope.filtro = {};
        
        $scope.gld = [];

        $scope.init = function () {
            $scope.getFotosReuniaoCelSearchAll();
        };
        
        /**
         * Recebe mensagens de outro controller
         */
        $scope.$on('handleBroadcast', function(event, args) {
            if(args.path === "/freuniao"){                
                if(args.tipo === "scroll"){
                    if ($(window).scrollTop() + $(window).height() >= $(document).height() - 80){
                        if (!$scope.loader && $scope.paginacao_stop === false) {
                            $scope.getFotosReuniaoCelSearchAll();
                        }
                    }
                }                
            }                
        }); 
        

        $scope.getAll = function(filtpesq){//Para ser chamado pela directive lightgallery
            $scope.getFotosReuniaoCelSearchAll(filtpesq);
        };
        $scope.getFotosReuniaoCelSearchAll = function (filtpesq) {
            $scope.loader = true;
            
            if(filtpesq){
                $scope.pg = 0;
                $scope.paginacao_stop = false;
                $scope.fr = [];
                $scope.gld = [];
                if($scope.search.length>0) $scope.filtro = {};
            }
            
            freuniaoService.getFotosReuniaoCelSearchAll($scope.pg, $scope.search, $scope.filtro).success(function (data) {
                $scope.pg = $scope.pg + 1;
                if ($scope.pg >= data.result.max_pag) {
                    $scope.paginacao_stop = true;
                }

                //$scope.fr = data.result.dados;
                data.result.dados.forEach(function (dados) {
                    $scope.fr.push(dados);//Por causa da paginação
                    var gl = {};
                    gl.src = $rootScope.rootUrlFotoReuniaoCel+''+dados.rcel_arq;
                    gl.thumb = $rootScope.rootUrlFotoReuniaoCel+''+dados.rcel_arq;
                    gl.subHtml = "dsfsdfsfsdfssdf";
                    $scope.gld.push(gl);
                });
                
                $scope.loader = false;
            }).error(function (data, status, headers, config) {
                Util.alertErrorMessage(data, status);
                $scope.loader = false;
            });
        };
        
        $scope.destr = false;
        $scope.openGalery = function(idx){
            idx = !idx ? 0 : idx;
            var $lg = $('#lightgallery');
            $lg.lightGallery({
                index: idx,
                loop: true,
                controls: false,
                download: false,
                hideBarsDelay: 3000, //Padrão 6000
                dynamic: true,
                dynamicEl: $scope.gld
            });
        };
        
        $scope.selecCelulaParaInfoCelModal = function(i){
            $scope.info_ce_s = i;
            $scope.info_ce_s.random = Math.random();//Importante
            $("#infoCelulaModal").modal('show');
        };
        
        /**
        * Compartilhar Célula
        * @param {arrayDeObjetos} i - Dados da Célula
        * @returns {undefined}
        */
        $scope.sendCelulaSharing = function (i) {
            redecelService.sendCelulaSharing(i);
        };
        

        /**
         * Start
         */
        $scope.init();
    }]);

