app.directive('login', function(){
    return {
        restrict: 'EA',
        templateUrl: 'app/c/login/loginTpl.html',
        replace: true,
        controller: function($scope, $rootScope, Util, $location, loginService){
            $scope.submitted = false;
            $scope.us = {};

            $scope.init = function(){

            };
            
            $scope.resetForm = function(){
                $scope.submitted = false;
                $scope.us = {};
                $scope.formLogin.$setPristine();
                $('html, body').animate({scrollTop: 0});
            };

            $scope.loginUs = function(){
                $scope.submitted = true;
                if($scope.formLogin.$invalid){
                    window.plugins.toast.showLongTop('Dados inválidos!');                
                    return false;
                }

                $scope.loader = true;

                loginService.loginUs($scope.us).success(function(data){
                    if(data.result.us_cod){
                        loginService.setLogin(data.result);
                        $scope.resetForm();
                        $('#loginModal').modal('hide');
                        
                        var redirect = localStorage.getItem('login_redirect_path') ? localStorage.getItem('login_redirect_path') : null;
                        if(redirect){
                            $location.path(localStorage.getItem('login_redirect_path'));
                            localStorage.removeItem('login_redirect_path');
                        }            
                        loginService.removeLocalStorageLogoutServerPendentToken();
                    }else{
                        window.plugins.toast.showLongTop('Dados incorretos!');
                    }
                    $scope.loader = false;
                }).error(function(data, status, headers, config){
                    Util.alertErrorMessage(data, status);
                    $scope.loader = false;
                });
            };

            $scope.setLogout = function(){
                loginService.setLogout();
            };

            $scope.init();
        }
    };
});

app.directive('perfil', function(){
    return {
        restrict: 'EA',
        replace: true,
        templateUrl: 'app/c/login/perfilTpl.html',
        controller: function($scope, $rootScope, Util, UtilData, $filter, loginService, usService){
            loginService.acessoLogado();
            
            $scope.us = {};
            $scope.submitted = false;
            $scope.loader = false;
            $scope.path_foto_us = $rootScope.rootUrlFotoUs;
            
            $('#perfilModal').on('shown.bs.modal', function (e) {
                $scope.getDadosUs();
                $scope.random = Util.random(1000);
                //$rootScope.apply();
            });
            
            $scope.init = function(){
                
            };
            
            /**
             * Fecha o Modal
             * @returns {undefined}
             */
            $scope.closeModal = function(){
                $('#perfilModal').modal('hide');
                $scope.resetForm();                
            };
            
            $scope.resetForm = function(){
                $scope.loader = false;
                $scope.us = {};
            };
            
            /**
             * Retorna os dados do usuário logado
             * @returns {undefined}
             */
            $scope.getDadosUs = function(){
                $scope.loader = true;
                var us_cod =  $rootScope.lg.us_cod;
                usService.getDadosUs(us_cod).success(function(data){
                    if(data.result === "logout"){loginService.setLogout(); return false;}
                    $scope.us = data.result.dados;
                    $scope.us.us_pass = "";
                    $scope.us.us_datanasc_br = $filter('date')(data.result.dados.us_datanasc, 'dd/MM/yyyy');
                    
                    $scope.loader = false;
                }).error(function(data, status, headers, config){
                    Util.alertErrorMessage(data, status);
                    $scope.loader = false;
                });
            };
            
            /**
             * Salvar dados do usuário logado
             * @returns {undefined}
             */
            $scope.salvarMeuPerfilUs = function(){
                if($scope.formPerfil.$invalid){
                    if($rootScope.deviceready){
                        window.plugins.toast.showLongTop('Dados inválidos!'); 
                    }else{
                        alert('Dados inválidos!');
                    }
                    return false;
                }
                if($scope.us.us_pass && ($scope.us.us_pass !== $scope.us.us_pass_confirm)){
                    if($rootScope.deviceready){
                        navigator.notification.alert('A senha não foi confirmada no campo "confirmar senha"!', null, 'Erro');
                    }else{
                        alert('A senha não foi confirmada no campo "confirmar senha"!');
                    }
                    return false;
                }          
                
                var us_datanasc = Util.formatDataString($scope.us.us_datanasc_br);
                us_datanasc = UtilData.convertStringForData(us_datanasc);
                
                if(!us_datanasc){
                    if($rootScope.deviceready){
                        navigator.notification.alert('Data de nascimento inválida!', null, 'Erro');
                    }else{
                        alert('Data de nascimento inválida!');
                    }                        
                    return false;
                }
                $scope.us.us_datanasc = us_datanasc;

                $scope.loader = true;
                
                usService.salvarMeuPerfilUs($scope.us).success(function(data){
                    if(data.result === "logout"){loginService.setLogout(); return false;}
                    
                    if(data.result.new_token){
                        localStorage.setItem('lg_token_session', data.result.new_token);
                        $rootScope.lg.token_session = data.result.new_token;
                    }

                    if($rootScope.deviceready){
                        window.plugins.toast.showLongTop('Operação realizada com sucesso!');
                    }else{
                        alert('Operação realizada com sucesso!');
                    }
                    
                    loginService.setLg(data.result);
                    $scope.closeModal();
                    
                    $scope.loader = false;
                }).error(function(data, status, headers, config){
                    Util.alertErrorMessage(data, status);
                    $scope.loader = false;
                });
            };
            
            
            /**
             * Start
             */
            $scope.init();
        }
    };
});