app.service('loginService', ['$rootScope', '$location', 'http', 'Util', function($rootScope, $location, http, Util){
    this.acessoLogado = function(){
        if(!localStorage.getItem('lg_token_session')){
            $location.path('/');
        }
    };
    
    this.loginUs = function(us){
        var url = $rootScope.rootUrl+"Dispositivos/loginDispositivoUs";
        
        var player_id_onesignal = $rootScope.player_id_onesignal ? $rootScope.player_id_onesignal : localStorage.getItem('player_id_onesignal');
        player_id_onesignal = $rootScope.deviceready ? player_id_onesignal : 'passdh73DWjsga82k1fh';
        
        var params = {
                disp_ativ_device_registration_id: player_id_onesignal,
                us_ig_cod: localStorage.getItem("disp_ig_cod"), 
                disp_ativ_ig_cod: localStorage.getItem("disp_ig_cod"),
                us_user: us.us_user, 
                us_pass: us.us_pass
         };
        if($rootScope.deviceready){
            params.disp_ativ_version_cordova = device.cordova;
            params.disp_ativ_modelo = device.model;
            params.disp_ativ_uuid = device.uuid;
            params.disp_ativ_version_os = device.version;
            params.disp_ativ_platform = device.platform;
        }else{     
            params.disp_ativ_version_cordova = "1";
            params.disp_ativ_modelo = "1";
            params.disp_ativ_uuid = "1";
            params.disp_ativ_version_os = "1";
            params.disp_ativ_platform = "1";
        }
        
        return http.post(url, params);
    };
    
    this.setLogin = function(r){
        $('html, body').animate({scrollTop: 0});

        var lider = r.ce_cod ? 1 : 0;//Para ser lider é necessário ter uma celula
        localStorage.setItem('lg_us_lider',lider);
        localStorage.setItem('lg_ce_cod_do_us_lider', r.ce_cod);
        localStorage.setItem('lg_ce_nome_do_us_lider', r.ce_nome);
        localStorage.setItem('lg_token_session', r.lg_token_session);
        
        this.setLg(r);

        $location.path('/');
    };
    
    this.setLg = function(r){
        if(r){
            localStorage.setItem('lg_us_cod',r.us_cod);
            localStorage.setItem('lg_us_nome',r.us_nome);
            localStorage.setItem('lg_us_coordenador',r.us_coordenador);
            localStorage.setItem('lg_us_supervisor',r.us_supervisor);
            localStorage.setItem('lg_us_admin',r.us_admin);
            localStorage.setItem('lg_us_p_post_msgs',r.us_p_post_msgs);

            this.setLgRoot();
        }   
    };
    
    this.setLgRoot = function(){
        $rootScope.lg.us_lider = localStorage.getItem('lg_us_lider');
        $rootScope.lg.ce_cod_do_us_lider = localStorage.getItem('lg_ce_cod_do_us_lider');
        $rootScope.lg.ce_nome_do_us_lider = localStorage.getItem('ce_nome_do_us_lider');
        $rootScope.lg.token_session = localStorage.getItem('token_session');
        
        $rootScope.lg.us_cod = localStorage.getItem('lg_us_cod');
        $rootScope.lg.us_nome = localStorage.getItem('lg_us_nome');
        $rootScope.lg.us_coordenador = localStorage.getItem('lg_us_coordenador') === "1" ? true : false;
        $rootScope.lg.us_supervisor = localStorage.getItem('lg_us_supervisor') === "1" ? true : false;
        $rootScope.lg.us_admin = localStorage.getItem('lg_us_admin') === "1" ? true : false;
        $rootScope.lg.us_p_post_msgs = localStorage.getItem('lg_us_p_post_msgs') === "1" ? true : false;
        
        $rootScope.lg.random = Util.random(10000);//Para os watchers que escutam o lg
    };
    
    
    /**
     * Retorna dados da sessão logada
     * @returns {loginService_L1.getLgSession.lg}
     */
    this.getLgSession = function(){
        var lg = {
            lg_token_session: localStorage.getItem('lg_token_session'),
            lg_us_cod: localStorage.getItem('lg_us_cod'),
            lg_ig_cod: localStorage.getItem('disp_ig_cod')        
        };
        return lg;
    };
    
    
    this.setLogout = function(no_dir){
        $('html, body').animate({scrollTop: 0});

        var tk = localStorage.getItem('lg_token_session');
        var ig_nome = localStorage.getItem('disp_ig_nome');
        this.logout();
        
        if(!no_dir){
            $location.path('/');
        }

        if($rootScope.deviceready){
            window.plugins.toast.showLongTop('Você foi desconectado da sua conta na igreja '+ig_nome+'!');
        }
        
        localStorage.setItem('logoutServerPendentToken',tk);        
        this.logoutServerPending(tk);        
                   
    };   
    
    this.logout = function(){
        //localStorage.clear();
        localStorage.removeItem('lg_token_session');
        localStorage.removeItem('lg_us_cod');
        localStorage.removeItem('lg_us_nome');
        localStorage.removeItem('lg_us_coordenador');
        localStorage.removeItem('lg_us_supervisor');

        localStorage.removeItem('lg_us_lider');
        localStorage.removeItem('lg_ce_cod_do_us_lider');
        localStorage.removeItem('lg_ce_nome_do_us_lider');

        localStorage.removeItem('lg_us_admin');
        localStorage.removeItem('lg_us_p_post_msgs');
        
        $rootScope.lg = {};

    };
    
    this.removeLocalStorageLogoutServerPendentToken = function(data){
        localStorage.removeItem('logoutServerPendentToken');
    };
    
    this.logoutServerPending = function(tk){
        if(!tk) return false;
        this.logoutServer(tk).success(this.removeLocalStorageLogoutServerPendentToken).error(function(data, status, headers, config){
            localStorage.setItem('logoutServerPendentToken',tk);
        });
    };
    
    this.logoutServer = function(tk){
        if(!tk) return false;
        var url = $rootScope.rootUrl+"Dispositivos/logoutDispositivoByUs/"+tk;        
        return http.get(url);
    };
}]);


