app.controller('msgsController', ['$scope', '$rootScope', 'Util', 'msgsService', 'bdAppService', function($scope, $rootScope, Util, msgsService, bdAppService){
    $rootScope.navtop.btnBack = true;    
    $rootScope.navtop.title = "Micro-blog";
    $('html, body').animate({scrollTop: 0},1);
    
    $scope.loader = false;
    $scope.paginacao_stop = false;
    $scope.pg = 0;
        
    $scope.msgs_list = [];
    
    $scope.init = function(){
        $scope.getMsgsAll(true);
    };
    
    /**
    * Recebe mensagens de outro controller
    */
    $scope.$on('handleBroadcast', function (event, args) {
        if (args.path === "/msgs") {
            if (args.tipo === "scroll") {
                if ($(window).scrollTop() + $(window).height() >= $(document).height() - 80) {
                    if (!$scope.loader && $scope.paginacao_stop === false) {
                        $scope.getMsgsAll();
                    }
                }
            }
        }
    }); 
    
    $scope.getMsgsAll = function(clear){
        $scope.loader = true;
        
        if(clear){
            $scope.pg = 0;
            $scope.paginacao_stop = false;
            $scope.msgs_list = [];
            
            $scope.getMsgsLocalAll();
        }
        
        msgsService.getMsgsAll($scope.pg).success(function(data){
            
            $scope.pg = $scope.pg + 1;
            if ($scope.pg >= data.result.max_pag) {
                $scope.paginacao_stop = true;
            }             
            
            //$scope.vd = data.result.dados;
            data.result.dados.forEach(function (dados) {
                $scope.msgs_list.push(dados);//Por causa da paginação
            });
                
            
            $scope.loader = false;
        }).error(function(data, status, headers, config){
            Util.alertErrorMessage(data, status);
            $scope.loader = false;
        });
    };
    
    $scope.getMsgsLocalAll = function(ultimo_registro){
        if(!$rootScope.deviceready) return false;
        $('html, body').animate({scrollTop: 0},1);
        
        //Adicionar mensagens pendentes de envio
        var db_app = bdAppService.conex();
        db_app.transaction(function(tx){
            
            var order = ultimo_registro ? "DESC" : "ASC";
            tx.executeSql('SELECT * FROM msgs WHERE msg_ig_cod = '+$rootScope.dispIg.ig_cod+' AND st_envio = 0 ORDER BY id_local '+order,[], function(tx, result){
                if(result.rows.length > 0){
                    var lgt = ultimo_registro ? 1 : result.rows.length;
                    
                    for (var i = 0; i < lgt; i++) {
                        var rs = result.rows.item(i);

                        var obj = new Object();
                        obj = rs;
                        obj.msg_cod = "";
                        obj.us_cod = localStorage.getItem('lg_us_cod');
                        obj.us_nome = localStorage.getItem('lg_us_nome');
                        obj.us_email = "";
                        obj.us_cel = "";                        
                        $scope.msgs_list.unshift(obj);                        
                    }
                }
            });
        },bdAppService.errorDB);
    };
    
    $scope.dirArq = function(i){
        return i.image_uri ? i.image_uri : $rootScope.rootUrl+"msgs/"+i.msg_arq;
    };
    
    /**
     * Start
     */
    $scope.init();
}]);


