app.directive('msgsendBox', function(){
    return {
        restrict: 'EA',
        replace: true,
        scope: {
            onInsertNew: '&',
            onRefreshList: '&'
        },
        templateUrl: 'app/tpls/msgsendbox.html',
        controller: function($scope, $rootScope, Util, bdAppService, msgsService){
            $scope.msg = {msg_msgtxt: ""};
            $scope.params = {};
            $scope.versiculo_selec = "";
            $scope.vis_biblia = false;
            
            $scope.$watch('versiculo_selec', function(newValue){
                if(newValue){
                    $scope.vis_biblia = false;
                    $scope.msg.msg_msgtxt += " "+newValue;
                    $scope.versiculo_selec = "";
                    $("#msg_msgtxt").css('height', '200px');
                }
            });
            
            $scope.init = function(){
                
            };
            
            
            
            /**
             * Capturar foto da câmera
             * @returns {undefined}
             */
            $scope.captureFotoCamera = function () {
                navigator.camera.getPicture($scope.onFotoCameraFileSuccess, $scope.onFail, { 
                    quality: 50,
                    targetWidth: 550,
                    correctOrientation: true,
                    destinationType: Camera.DestinationType.FILE_URI,
                    sourceType: Camera.PictureSourceType.CAMERA,
                    encodingType: Camera.EncodingType.JPEG,
                    mediaType: Camera.MediaType.PICTURE,
                    saveToPhotoAlbum: false
                });
            };
            $scope.onFotoCameraFileSuccess = function (imageData) {
//                $scope.$apply(function () {
//                    $scope.src_f = imageData;
//                });
                
                $scope.params = {
                    image_uri: imageData,
                    mime: "image/jpeg",
                    msg_msgtxt: $scope.msg.msg_msgtxt ? $scope.msg.msg_msgtxt : "",
                    nome_arq: $scope.gerarNomeArq("jpg"),
                    midia: $rootScope.MIDIA_IMG,
                    tipo_cap_foto: 'camera'
                };
                
                $scope.insertNewMsg();
            };
            
            /**
             * Selecionar Foto na Galeria do dispositivo
             * @returns {undefined}
             */
            $scope.getFotoGaleria = function() {
                navigator.camera.getPicture($scope.onFotoGaleriaURISuccess, $scope.onFail, { 
                    quality: 35,  
                    targetWidth: 650,
                    //allowEdit : true, //crop imagem
                    destinationType: Camera.DestinationType.FILE_URI,
                    //sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                    sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM,
                    encodingType: Camera.EncodingType.JPEG,
                    mediaType: Camera.MediaType.PICTURE//Opções: PICTURE, VIDEO ou ALLMEDIA
                });
            };
            $scope.onFotoGaleriaURISuccess = function(imageURI) {

//                $scope.$apply(function () {
//                    $scope.src_f = imageURI;
//                });

                $scope.params = {
                    image_uri: imageURI,
                    mime: "image/jpeg",
                    msg_msgtxt: $scope.msg.msg_msgtxt ? $scope.msg.msg_msgtxt : "",
                    nome_arq: $scope.gerarNomeArq("jpg"),
                    midia: $rootScope.MIDIA_IMG,
                    tipo_cap_foto: 'galeria'
                };    
                
                $scope.insertNewMsg();
            };
            
            // start video capture
            $scope.capVideo = function(){
                navigator.device.capture.captureVideo($scope.capVideoSuccess, $scope.capVideoError, {limit:1, duration: 15});
            };
            $scope.capVideoSuccess = function(mediaFiles) {
                var i, path, len;
                for (i = 0, len = mediaFiles.length; i < len; i += 1) {
                    path = mediaFiles[i].fullPath;
                    
                    /*
                    mediaFiles[i].getFormatData(function(data) {
                        if(data.duration > 15) {
                            navigator.notification.alert('O vídeo é mais longo do que os 15 segundos permitidos. Por favor, gravar um novo vídeo sem ultrapassar o limite de tempo.', null, 'Limite ultrapassado');
                        }else{
                    
                        }
                    }); 
                    */

                    var max_mb = 16;//MB
                    if(mediaFiles[i].size > max_mb*1048576){
                        navigator.notification.alert('O sistema só permite Vídeo com no máximo 16MB. Dica: Diminua a resolução de captura de vídeo do seu dispositivo e/ou faça vídeos mais curtos.', null, 'Erro');
                    }else{
                        
                        $scope.params = {
                            image_uri: path,
                            mime: "video/mpeg",
                            msg_msgtxt: $scope.msg.msg_msgtxt ? $scope.msg.msg_msgtxt : "",
                            nome_arq: $scope.gerarNomeArq("mp4"),
                            midia: $rootScope.MIDIA_VIDEO,
                            tipo_cap_foto: ''
                        };
                        
                        $scope.insertNewMsg();
                    }

                }
            };
            $scope.capVideoError = function(error) {
                var erro_txt = "";
                var tipo_alert = "alert";
                if(error.code === CaptureError.CAPTURE_INTERNAL_ERR){
                    erro_txt = "A câmera ou microfone não conseguiu capturar a imagem ou som";
                }else if(error.code === CaptureError.CAPTURE_APPLICATION_BUSY){
                    erro_txt = "A câmera ou aplicativo de captura de áudio está cumprindo um outro pedido de captura";
                }else if(error.code === CaptureError.CAPTURE_INVALID_ARGUMENT){
                    erro_txt = "Uso incorreto do API - Favor contactar o desenvolvedor do App";
                }else if(error.code === CaptureError.CAPTURE_NO_MEDIA_FILES){
                    erro_txt = "Operação cancelada pelo usuário";
                    tipo_alert = 'toast';
                }else if(error.code === CaptureError.CAPTURE_NOT_SUPPORTED){
                    erro_txt = "A operação de captura solicitado não é suportado";
                }

                if(tipo_alert === 'toast'){
                    window.plugins.toast.showShortBottom(erro_txt);
                }else{
                    navigator.notification.alert(erro_txt + ' - Erro nº: ' + error.code, null, 'Erro na captura');
                }    
            };
            
            
            /**
             * Gerar nome do arquivo de mídia
             * @param {type} ext
             * @returns {String}
             */
            $scope.gerarNomeArq = function(ext) {
                var d = new Date(),
                        month = '' + (d.getMonth() + 1),
                        day = '' + d.getDate(),
                        year = '' + d.getFullYear(),
                        hours = '' + d.getHours(),
                        minutes = '' + d.getMinutes(),
                        seconds = '' + d.getSeconds();
                var num_al = Math.floor((Math.random() * 10000) + 1);
                var nome_arq = num_al + day + month + year + hours + minutes + seconds;
                return nome_arq + '.' + ext;
            };
            
            $scope.onFail = function(message) {
                window.plugins.toast.showLongTop('Motivo da falha: ' + message);
            };
            
            $scope.closeMsgsModal = function(){
                $scope.src_f = null;
                $scope.msg = {msg_msgtxt: ""};
                if($rootScope.deviceready){
                    window.plugins.insomnia.allowSleepAgain();//Permite o dispositivo pegar no sono
                }                    
                $("#msg_msgtxt").css('height', '120px');
                $('#msgModal').modal('hide');                              
            };
            
            $scope.openBiblia = function(){                
                $scope.vis_biblia = true;
            };
            $scope.closeBiblia = function(){
                $scope.vis_biblia = false;
                if($rootScope.deviceready){
                    window.plugins.insomnia.allowSleepAgain();//Permite o dispositivo pegar no sono
                }    
            };
            
            $scope.sendSoTexto = function(){                
                $scope.params = {
                    image_uri: "",
                    mime: "",
                    msg_msgtxt: $scope.msg.msg_msgtxt ? $scope.msg.msg_msgtxt : "",
                    nome_arq: "",
                    midia: 0,
                    tipo_cap_foto: ""
                };
                $scope.insertNewMsg();
            };
            
            /**
             * Inserir mensagem no banco local
             * @param {type} image_uri
             * @param {type} mime
             * @param {type} msg_msgtxt
             * @param {type} nome_arq
             * @param {type} midia
             * @param {type} tipo_cap_foto
             * @returns {Boolean}
             */
            $scope.insertNewMsg = function(){
                if(!localStorage.getItem('disp_ig_cod') || !localStorage.getItem('lg_us_cod') ){
                     navigator.notification.alert('Não foi possível adicionar mensagem!', 'Operação cancelada');
                     return false;
                };
                
                $scope.params.msg_msgtxt = Util.replaceAll($scope.params.msg_msgtxt,"'","\'");
                $scope.params.msg_msgtxt = Util.replaceAll($scope.params.msg_msgtxt,'"',"\'");
                
                var db_app = bdAppService.conex();
                db_app.transaction(function(tx){
                    tx.executeSql('INSERT INTO msgs (msg_ig_cod, msg_post_us_cod, msg_msgtxt, msg_arq, msg_midia, mime, image_uri, tipo_cap_foto, st_envio) VALUES ('+$rootScope.dispIg.ig_cod+', '+$rootScope.lg.us_cod+', "'+$scope.params.msg_msgtxt+'", "'+$scope.params.nome_arq+'", "'+$scope.params.midia+'", "'+$scope.params.mime+'", "'+$scope.params.image_uri+'", "'+$scope.params.tipo_cap_foto+'", 0)',[], function(tx, result){
                        $scope.onInsertNew();
                        $scope.closeMsgsModal();
                        
                        //Get último registro
                        tx.executeSql('SELECT LAST_INSERT_ROWID() AS ID',[], function(tx, result){
                            if(result.rows.length > 0){
                                var rs = result.rows.item(0);
                                $rootScope.msgs_loader['id_'+rs.ID] = true;
                            }                            
                        });
                        
                        if(!msgsService.sendMsgsServidorStartProcess){
                            msgsService.sendMsgsServidor();
                        }else{
                            setTimeout(function(){
                                if(!msgsService.sendMsgsServidorStartProcess){
                                    msgsService.sendMsgsServidor();
                                }
                            }, 7*1000);
                        }                       
                                                        
                    });
                },bdAppService.errorDB);
            };

            
            
            /**
             * Start
             */
            $scope.init();
        }
    };
});

