app.factory('msgsService', ['http', '$rootScope', 'bdAppService', function (http, $rootScope, bdAppService) {
        var df = {};
        df.sendMsgsServidorStartProcess = false;

        /**
         * Retorna registros de todas as mensagens da igreja
         * @param {type} pg
         * @returns {unresolved}
         */
        df.getMsgsAll = function (pg) {
            var url = $rootScope.rootUrl + "Msgs/getMsgsAll";
            var params = {
                ig_cod: localStorage.getItem('disp_ig_cod'),
                pg: pg
            };

            return http.post(url, params);
        };

        /**
         * Salvar Mensagem de Texto (Só Texto)
         * @param {type} msg
         * @returns {unresolved}
         */
        var salvarMsgServer = function (msg) {
            var url = $rootScope.rootUrl + "Msgs/salvarMsg";
            var params = {
                ig_cod: localStorage.getItem('disp_ig_cod'),
                msg_post_us_cod: localStorage.getItem('lg_us_cod'),
                msg_msgtxt: $.trim(msg.msg_msgtxt),
                msg_midia: $rootScope.MIDIA_NULL
            };

            return http.post(url, params);
        };

        df.sendMsgsServidorStart = function () {
            if(!$rootScope.deviceready) return false;
            
            var db_app = bdAppService.conex();
            db_app.transaction(function (tx) {
                tx.executeSql('SELECT * FROM msgs WHERE msg_ig_cod = ' + $rootScope.dispIg.ig_cod + ' AND st_envio = 0 ORDER BY id_local ASC', [], function (tx, result) {
                    if (result.rows.length > 0) {
                        for (var i = 0; i < result.rows.length; i++) {
                            var rs = result.rows.item(i);
                            $rootScope.msgs_loader["id_"+rs.id_local] = true;
                        }
                        setTimeout(function () {
                            if (!df.sendMsgsServidorStartProcess) {
                                df.sendMsgsServidor();
                            }
                        }, 2 * 1000);
                    }
                });
            }, bdAppService.errorDB);
        };

        df.sendMsgsServidor = function () {
            var db_app = bdAppService.conex();
            db_app.transaction(function (tx) {
                tx.executeSql('SELECT * FROM msgs WHERE msg_ig_cod = ' + $rootScope.dispIg.ig_cod + ' AND st_envio = 0 ORDER BY id_local ASC LIMIT 1', [], function (tx, result) {
                    if (result.rows.length > 0) {
                        df.sendMsgsServidorStartProcess = true;
                        for (var i = 0; i < result.rows.length; i++) {
                            var rs = result.rows.item(i);

                            $rootScope.msgs_loader["id_"+rs.id_local] = true;

                            if (rs.image_uri.length > 0) {
                                if (!($rootScope.msgs_perc["id_"+rs.id_local] > 0)) {
                                    //Envia mensagem com mídia
                                    $rootScope.msgs_perc["id_"+rs.id_local] = 1;
                                    uploadMsgs(rs.image_uri, rs.mime, rs.id_local, rs.msg_msgtxt, rs.msg_arq, rs.msg_midia, rs.tipo_cap_foto);
                                }
                            } else {
                                if (!($rootScope.msgs_perc["id_"+rs.id_local] > 0)) {
                                    $rootScope.msgs_perc["id_"+rs.id_local] = 1;
                                    salvarMsg(rs, rs.id_local);
                                }
                            }
                        }

                        setTimeout(function () {
                            $rootScope.$apply(function () {
                                $rootScope.count++;
                            });

                            df.sendMsgsServidor();
                        }, 2 * 1000);
                    } else {
                        df.sendMsgsServidorStartProcess = false;
                    }
                });
            }, bdAppService.errorDB);
        };

        var salvarMsg = function (msg, id_local) {
            //Envia mensagem só de texto
            salvarMsgServer(msg).success(function (data) {
                delLocalMsgs(id_local);
            }).error(function (data, status, headers, config) {
                $rootScope.msgs_perc["id_"+id_local] = 0;
            });
        };

        var delLocalMsgs = function (id_local) {
            var db_app = bdAppService.conex();
            db_app.transaction(function (tx) {
                tx.executeSql('DELETE FROM msgs WHERE id_local=' + id_local, [], function (tx, result) {
                    $rootScope.msgs_loader["id_"+id_local] = null;
                    $rootScope.msgs_perc["id_"+id_local] = 0;
                });
            }, bdAppService.errorDB);
        };

        var uploadMsgs = function (image_uri, mime, id_local, msg_msgtxt, nome_arq, midia, tipo_cap_foto) {
            var uri = encodeURI($rootScope.rootUrl + "upload_file_msgs.php");
            var _nome_arq = nome_arq ? nome_arq : image_uri.substr(image_uri.lastIndexOf('/') + 1);

            var options = new FileUploadOptions();
            options.fileKey = "file";
            options.fileName = _nome_arq;
            options.mimeType = mime;
            options.chunkedMode = true;//Padrão é true
            options.headers = {
                Connection: "close"
            };

            var params = {};
            params.ig_cod = localStorage.getItem('disp_ig_cod');
            params.msg_post_us_cod = localStorage.getItem('lg_us_cod');
            params.msg_msgtxt = msg_msgtxt;
            params.msg_tipo_cap_foto = tipo_cap_foto;
            params.msg_midia = midia;

            options.params = params;

            var ft = new FileTransfer();

            ft.onprogress = function (progressEvent) {
                if (progressEvent.lengthComputable) {
                    $rootScope.$apply(function () {
                        $rootScope.msgs_perc["id_"+id_local] = Math.floor(progressEvent.loaded / progressEvent.total * 100);
                    });
                } else {
                    //               
                }
            };
            ft.upload(image_uri, uri, function (result) {
                //alert('Upload realizado com sucesso: ' + result.responseCode) + '. bytes enviados: ' + result.bytesSent;
                //SUCCESS
                delLocalMsgs(id_local);

            },
                    function (error) {
                        var erro_txt = "";
                        if (error.code === FileTransferError.FILE_NOT_FOUND_ERR) {
                            erro_txt = "arquivo não encontrado";
                        } else if (error.code === FileTransferError.INVALID_URL_ERR) {
                            erro_txt = "URL inválida";
                        } else if (error.code === FileTransferError.CONNECTION_ERR) {
                            erro_txt = "Erro de conexão";
                        } else if (error.code === FileTransferError.ABORT_ERR) {
                            erro_txt = "Operação abortada";
                        }

                        //DELETA REGISTRO NO BD LOCAL CASO OCORRA UM ERRO DIFERENTE DO ERRO DE CONEXÃO
                        if (error.code !== FileTransferError.CONNECTION_ERR) {
                            delLocalMsgs(id_local);
                            window.plugins.toast.showLongCenter(erro_txt);
                        }

                        $rootScope.msgs_perc["id_"+id_local] = 0;

                        options = null;
                        ft = null;
                        //navigator.notification.alert(erro_txt + ' - Erro nº: ' + error.code, null, 'Erro');
                    },
                    options);

        };

        return df;
    }]);
