app.controller("pedoracaoController", ["$scope", "$rootScope", "$location", "Util", "uf_arr", "loginService", "pedoracaoService", function($scope, $rootScope, $location, Util, uf_arr, loginService, pedoracaoService){
        $rootScope.navtop.btnBack = true;
        $rootScope.navtop.title = "Pedido de Oração";
        
        $scope.po = {};
        $scope.uf_arr = uf_arr;
        $scope.submitted = false;        
        $scope.loader = false;

        $scope.init = function(){
            $scope.po.ped_nome = localStorage.getItem('disp_ativ_nome_us');
            $scope.po.ped_uf = localStorage.getItem('disp_ig_uf');
            $scope.po.ped_cidade = localStorage.getItem('disp_ig_cidade');
        };

        $scope.resetForm = function(){
            $scope.loader = false;
            $scope.po = {};
        };

        
        /**
         * Enviar o pedido de oração
         * @returns {undefined}
         */
        $scope.salvarPedidoOracao = function(){
            if($scope.formPedOracao.$invalid){
                if($rootScope.deviceready){
                    window.plugins.toast.showLongTop('Dados inválidos!'); 
                }else{
                    alert('Dados inválidos!');
                }
                return false;
            }

            $scope.loader = true;

            pedoracaoService.salvarPedidoOracao($scope.po).success(function(data){
                if(data.result === "logout"){loginService.setLogout(); return false;}

                if($rootScope.deviceready){
                    window.plugins.toast.showLongCenter('O seu pedido foi enviado com sucesso!');
                }else{
                    alert('Operação realizada com sucesso!');
                }

                $scope.loader = false;
                $location.path('/');
            }).error(function(data, status, headers, config){
                Util.alertErrorMessage(data, status);
                $scope.loader = false;
            });
        };


        /**
         * Start
         */
        $scope.init();
}]);