app.directive('ctrlEntregaRelCelulas', function(){
    return {
        restrict: "EA",
        templateUrl: "app/c/redecel/tpls/ctrlEntregaRelCelulasTpl.html",
        link: function(scope, el, attrs){
            componentHandler.upgradeAllRegistered();
        },
        controller: function($scope, $rootScope, Util, wfPaginationService, redecelService, loginService, rede_celulas_arr){
            loginService.acessoLogado();
            
            $scope.rede_celulas_arr = rede_celulas_arr;
    
            $scope.et = [];
            $scope.filtro = {};
            $scope.pag = {};
            $scope.loader = false;

            //Para paginação Mês/Ano
            $scope.pag = wfPaginationService.getPagMesAnoAtual();
            //---

            $scope.init = function(){
                angular.element("html body").scrollTop(0); 
                $scope.getReunioesPorPeriodoDeEntregaAll();
            };

            /**
             * Retorna registros das entregas de relatórios
             * @returns {undefined}
             */
            $scope.getReunioesPorPeriodoDeEntregaAll = function(){
                $scope.loader = true;
                $scope.et = [];

                redecelService.getReunioesPorPeriodoDeEntregaAll($scope.pag, $scope.filtro).success(function(data){
                    if(data.result === "logout"){loginService.setLogout(); $scope.loader = false; return false;}
                    $scope.et = data.result;

                    $scope.loader = false;
                }).error(function(data, status, headers, config){
                    Util.alertErrorMessage(data, status);
                    $scope.loader = false;
                });
            };

            $scope.t_realiz = function(i){
                return parseInt(i.t_entregue)+parseInt(i.t_cancelado);
            };
            $scope.perc = function(i){
                return Math.floor( ( $scope.t_realiz(i)/i.t_reg )*100 );
            };

            /**
             * Start
             */
            $scope.init();
        }
    };
});



app.directive('desempCelulas', function(){
    return {
        restrict: "EA",
        templateUrl: "app/c/redecel/tpls/desempCelulasTpl.html",
        link: function(scope, el, attrs){
            componentHandler.upgradeAllRegistered();
        },
        controller: function($scope, $rootScope, Util, wfPaginationService, redecelService, loginService, rede_celulas_arr){
            //loginService.acessoLogado();
            
            $scope.rede_celulas_arr = rede_celulas_arr;
    
            $scope.dp = [];
            $scope.filtro = {};
            $scope.pag = {};
            $scope.loader = false;

            //Para paginação Ano
            $scope.pag = wfPaginationService.getPagMesAnoAtual();
            //---

            $scope.init = function(){
                angular.element("html body").scrollTop(0); 
                $scope.getDesempMensalCelulaAll();
            };

            /**
             * Retorna registros das entregas de relatórios
             * @returns {undefined}
             */
            $scope.getDesempMensalCelulaAll = function(){
                $scope.loader = true;
                $scope.dp = [];

                redecelService.getDesempMensalCelulaAll($scope.pag, $scope.filtro).success(function(data){
                    if(data.result === "logout"){loginService.setLogout(); $scope.loader = false; return false;}
                    $scope.dp = data.result;
                    
                    $scope.total_ofertas_proposito = 0;
                    $scope.total_conversoes = 0;
                    $scope.total_reconciliacoes = 0;
                    $scope.total_reunioes = 0;
                    
                    angular.forEach($scope.dp, function(d){
                        $scope.total_ofertas_proposito = $scope.total_ofertas_proposito + parseFloat(d.tt_ofertas);
                        $scope.total_conversoes = $scope.total_conversoes + parseInt(d.tt_conversoes);
                        $scope.total_reconciliacoes = $scope.total_reconciliacoes + parseInt(d.tt_reconciliacoes);
                        
                        $scope.total_reunioes = $scope.total_reunioes + parseInt(d.tt_reunioes);
                    });

                    $scope.loader = false;
                }).error(function(data, status, headers, config){
                    Util.alertErrorMessage(data, status);
                    $scope.loader = false;
                });
            };

            /**
             * Start
             */
            $scope.init();
        }
    };
});



app.directive('celulas', function(){
    return {
        restrict: 'EA',
        templateUrl: 'app/c/redecel/tpls/celulasTpl.html',
        link: function(scope, el, attrs){
            componentHandler.upgradeAllRegistered();
        },
        controller: function($scope, Util, rede_celulas_arr, redecelService){
            $scope.rede_celulas_arr = rede_celulas_arr;

            $scope.loader = false;
            $scope.paginacao_stop = false;
            $scope.pg = 0;

            $scope.search_modo = false;
            $scope.search = "";

            $scope.ce = [];
            $scope.ce_s = {};
            $scope.filtro = {};

            $scope.init = function () {
                angular.element("html body").scrollTop(0); 
                //$scope.getCelulasAll();
            };

            /**
             * Recebe mensagens de outro controller
             */
            $scope.$on('handleBroadcast', function(event, args) {
                if(args.path === "/redecelulas" && $scope.start === "celulas"){                
                    if(args.tipo === "scroll"){
                        if ($(window).scrollTop() + $(window).height() >= $(document).height() - 80){
                            if (!$scope.loader && $scope.paginacao_stop === false) {
                                $scope.getCelulasAll();
                            }
                        }
                    }                
                }                
            });  

            $scope.selecCelulaParaInfoCelModal = function(i){
                $scope.info_ce_s = i;
                $scope.info_ce_s.random = Math.random();//Importante
                $("#infoCelulaModal").modal('show');
            };
            $scope.selecCelulaParaRelCelModal = function(i){
                $scope.relcel_ce_s = i;
                $scope.relcel_ce_s.random = Math.random();//Importante
                $("#relCelModal").modal('show');
            };

            /**
             * Retorna registros paginados das células ativas
             * @param {type} filtpesq
             * @returns {undefined}
             */
            $scope.getCelulasAll = function (filtpesq) {
                $scope.loader = true;

                if(filtpesq){
                    $scope.pg = 0;
                    $scope.paginacao_stop = false;
                    $scope.ce = []; 
                    if($scope.search.length>0) $scope.filtro = {};
                }
                console.log("pg: "+$scope.pg);

                redecelService.getCelulasAll($scope.pg, $scope.search, $scope.filtro).success(function (data) {
                    $scope.pg = $scope.pg + 1;
                    if ($scope.pg >= data.result.max_pag) {
                        $scope.paginacao_stop = true;
                    }

                    //$scope.ce = data.result.dados;
                    data.result.dados.forEach(function (dados) {
                        $scope.ce.push(dados);//Por causa da paginação
                    });

                    $scope.loader = false;
                }).error(function (data, status, headers, config) {
                    Util.alertErrorMessage(data, status);
                    $scope.loader = false;
                });
            };
            
            /**
            * Compartilhar Célula
            * @param {arrayDeObjetos} i - Dados da Célula
            * @returns {undefined}
            */
            $scope.sendCelulaSharing = function (i) {
                redecelService.sendCelulaSharing(i);
            };


            /**
             * Start
             */
            $scope.init();
        }
    };
});


app.directive('infoCelula', function(){
    return {
        restrict: 'EA',
        templateUrl: 'app/c/redecel/tpls/infoCelulaTpl.html',
        scope: {
            ce_s: '=ce'
        },
        link: function(scope, el, attrs){
            componentHandler.upgradeAllRegistered();
        },
        controller: function($scope, $rootScope, redecelService){
            $scope.loader = false;            
            $scope.ce_s = {};
            $scope.path_foto_us = $rootScope.rootUrlFotoUs;
            
            $scope.init = function () {
                
            };
            
            $scope.$watch('ce_s', function(newValue){
                if(newValue.ce_cod){//Importante
                    //TODO
                }                                       
            });
            
            /**
             * Fecha Modal
             * @returns {undefined}
             */
            $scope.closeModal = function(){
                var tab = "#mdl-tabs-infocelula .mdl-tabs__tab";
                var panel = "#mdl-tabs-infocelula .mdl-tabs__panel";
                angular.element(tab).removeClass('is-active');
                angular.element(panel).removeClass('is-active');                
                angular.element(tab+':first').addClass('is-active');
                angular.element(panel+':first').addClass('is-active');
                
                $('#infoCelulaModal').modal('hide');
                $scope.resetModalInfoCelula();                
            };
            
            $scope.resetModalInfoCelula = function(){   
                $scope.loader = false; 
                $scope.ce_s = {};
            };
            
            /**
            * Compartilhar Célula
            * @param {arrayDeObjetos} i - Dados da Célula
            * @returns {undefined}
            */
            $scope.sendCelulaSharing = function (i) {
                redecelService.sendCelulaSharing(i);
            };
            
            $scope.onNotFoundLatLngMap = function(){
                if($rootScope.deviceready){
                    window.plugins.toast.showLongCenter('O líder ainda não fez a geolocalização da célula.');
                }else{
                    alert('Não foi possível localizar a célula no mapa. O líder da célula ainda não fez a geolocalização da célula.');
                }                
            };

            /**
             * Start
             */
            $scope.init();
        }
    };
});


app.directive('relCel', function(){
    return {
        restrict: 'EA',
        templateUrl: 'app/c/redecel/tpls/relCelTpl.html',
        scope: {
            ce_s: '=ce',
            onRefresh: '&'
        },
        link: function(scope, el, attrs){
            componentHandler.upgradeAllRegistered();
        },
        controller: function($scope, $rootScope, $location, Util, loginService, redecelService){
            
            $scope.loader = false;
            $scope.path_foto_us   = $rootScope.rootUrlFotoUs;
            $scope.path_foto_reun = $rootScope.rootUrlFotoReuniaoCel;
            
            $scope.re_list = [];
            
            $scope.ce_s = {};
            $scope.sendOk = false;
            
            $scope.loader_cancel = [];
            $scope.loader_novadata = [];
            
            $scope.init = function () {
                
            };
            
            $scope.$watch('ce_s', function(newValue){
                if(newValue.ce_cod){//Importante
                    $scope.getDatasPendentesDeReunioesPorLiderCelula();
                }                                       
            });

            /**
             * Retorna registros das datas de reuniões com envio pendentes da célula selecionada
             * @returns {undefined}
             */
            $scope.getDatasPendentesDeReunioesPorLiderCelula = function () {
                $scope.loader = true;

                redecelService.getDatasPendentesDeReunioesPorLiderCelula($scope.ce_s.ce_cod).success(function (data) {
                    if(data.result === "logout"){loginService.setLogout(); return false;}
                    $scope.re_list = data.result;

                    $scope.loader = false;
                }).error(function (data, status, headers, config) {
                    Util.alertErrorMessage(data, status);
                    $scope.loader = false;
                });
            };
            
            /**
             * Retorna o registro de uma determinada célula
             * @param {type} rcel_cod
             * @returns {undefined}
             */
            $scope.getDadosReuniao = function(rcel_cod){
                $scope.loader = true;
                
                redecelService.getDadosReuniao(rcel_cod).success(function(data){
                    if(data.result === "logout"){loginService.setLogout(); return false;}
                    
                    $scope.re = data.result;
                    $scope.re.rcel_evangelizacao        = $scope.re.rcel_evangelizacao ? "1" : "0";
                    $scope.re.rcel_acaosocial           = $scope.re.rcel_acaosocial ? "1" : "0";
                    $scope.re.rcel_visit_supervisao     = $scope.re.rcel_visit_supervisao ? "1" : "0";
                    $scope.re.rcel_havera_multiplicacao = $scope.re.rcel_havera_multiplicacao ? "1" : "0";
                    
                    $scope.loader = false;
                }).error(function(data, status, headers, config){
                    Util.alertErrorMessage(data, status);
                    $scope.loader = false;
                });
            };
            
            /**
             * Fecha o Modal
             * @returns {undefined}
             */
            $scope.closeModal = function(){
                $('#relCelModal').modal('hide');
                $scope.resetModalRelCel();                
            };
            
            $scope.resetModalRelCel = function(){
                $scope.loader = false; 
                $scope.re = null; 
                $scope.re_list = [];
                $scope.ce_s = {};
                if($scope.sendOk) $scope.onRefresh();
                $scope.sendOk = false;
                //angular.element("html body").scrollTop(0); 
            };
            
            $scope.resetForm = function(){
                $scope.re = null;
            };
            
            /**
             * Enviar Relatório da reunião
             * @returns {undefined}
             */
            $scope.salvarReuniaoCel = function(){
                $scope.loader = true;
                                
                redecelService.salvarReuniaoCel($scope.re).success(function(data){
                    if(data.result === "logout"){loginService.setLogout(); return false;}
                    
                    $scope.loader = false;
                    $scope.sendOk = true;
                    
                    window.plugins.toast.showLongCenter('Operação realizada com sucesso!');  
                    $scope.closeModal();
                    
                }).error(function(data, status, headers, config){
                    Util.alertErrorMessage(data, status);
                    $scope.loader = false;
                });
            };
            
            $scope.transfReuniaoPara = function(rcel_cod, _novadata, idx){
                $scope.loader_novadata[idx] = true;
                var novadata = Util.parseDate(Util.formatDataString(_novadata));
                
                redecelService.transfReuniaoPara(rcel_cod, novadata).success(function(data){
                    if(data.result === "logout"){loginService.setLogout(); return false;}                    
                    
                    $scope.re_list[idx].novadatareuniao = "";
                    $scope.loader_novadata[idx] = false;
                    $scope.getDatasPendentesDeReunioesPorLiderCelula();
                }).error(function (data, status, headers, config) {
                    $scope.loader_novadata[idx] = false;
                    window.plugins.toast.showLongCenter('ERRO: '+data.error.text);
                });
            };
            
            $scope.cancelarReuniaoConfirm = function(rcel_cod, idx){
                navigator.notification.confirm(
                    'Confirmar cancelamento da reunião? Esta operação não poderá ser desfeita!',
                     function(buttonIndex){
                         if(buttonIndex === 1){
                             $scope.cancelarReuniao(rcel_cod, idx);
                         }
                     },
                    'Confirmar Operação',//titulo
                    ['Confirmar','Cancelar']//buttonLabels
                );
            };
            
            $scope.cancelarReuniao = function(rcel_cod, idx){
                $scope.loader_cancel[idx] = true;
                
                redecelService.setStatusReuniao(rcel_cod, 2).success(function(data){
                    if(data.result === "logout"){loginService.setLogout(); return false;}
                    
                    $scope.getDatasPendentesDeReunioesPorLiderCelula();
                    
                    $scope.loader_cancel[idx] = false;
                }).error(function (data, status, headers, config) {
                    $scope.loader_cancel[idx] = false;
                    window.plugins.toast.showLongCenter('ERRO: '+data.error.text);
                });
            };
            

            /**
             * Start
             */
            $scope.init();
        }
    };
});


app.directive('detalhesDaReuniao', function(){
    return {
        restrict: 'EA',
        templateUrl: 'app/c/redecel/tpls/detalhesDaReuniaoTpl.html',
        scope: {
            rcel: '='
        },
        link: function(scope, el, attrs){
            componentHandler.upgradeAllRegistered();
        },
        controller: function($scope, $rootScope, redecelService){
            $scope.path_foto_us = $rootScope.rootUrlFotoUs;
            
            $scope.init = function () {
                
            };
            
            /**
             * Fecha Modal
             * @returns {undefined}
             */
            $scope.closeModal = function(){
                angular.element(".modal-body").scrollTop(0);
                $('#detalhesReuniaoModal').modal('hide');              
            };
            
            

            /**
             * Start
             */
            $scope.init();
        }
    };
});