app.service('redecelService', ['$rootScope', 'http', 'Util', 'loginService', function($rootScope, http, Util, loginService){
    
    this.getReunioesPorPeriodoDeEntregaAll = function(pag, filtro){
        var url = $rootScope.rootUrl+"Celula/getReunioesPorPeriodoDeEntregaAll";
        var params = {            
            lg: loginService.getLgSession(),
            ce_ig_cod: $rootScope.dispIg.ig_cod,
            us_cod: $rootScope.lg.us_cod,
            rede_filtro: filtro.rede_cod,
            mes_filtro: pag.mes,
            ano_filtro: pag.ano
        };
        
        return http.post(url, params);
    };
    
    
    
    /**
    * Retorna registros paginados das células ativas
    * @param {type} pg Número da página
    * @param {type} search Pesquisar por
    * @param {type} filtro Filtros
    * @returns {unresolved}
    */
        this.getCelulasAll = function (pg, search, filtro) {
            var url = $rootScope.rootUrl + "Celula/getCelulasAll";
            var params = {
                ig_cod: localStorage.getItem('disp_ig_cod'),
                parameter: search,
                pg: pg + 1,
                regporpag: 12,
                filtro: filtro,
                ce_status: 1
            };

            return http.post(url, params);
        };
    
    
    /**
     * Desempenho Mensal das Celulas por ano
     * @param {type} pg
     * @param {type} filtro
     * @returns {unresolved}
     */
    this.getDesempMensalCelulaAll = function (pg, filtro) {
        var url = $rootScope.rootUrl+"Celula/getDesempMensalCelulaAll";
        var params = {
            lg: loginService.getLgSession(),
            ce_ig_cod: $rootScope.dispIg.ig_cod,
            us_cod: $rootScope.lg.us_cod,
            rede_filtro: filtro.rede_cod,
            ano_filtro: pg.ano
        };
        
        return http.post(url, params);
    };
    
    /**
     * Retorna registros por data de todas as reuniõe pendentes de uma determinada célula
     * @param {type} ce_cod
     * @returns {unresolved}
     */
    this.getDatasPendentesDeReunioesPorLiderCelula = function (ce_cod) {
        var url = $rootScope.rootUrl+"Celula/getDatasPendentesDeReunioesPorLiderCelula";
        var params = {
            lg: loginService.getLgSession(),
            ce_ig_cod: $rootScope.dispIg.ig_cod,
            us_cod: $rootScope.lg.us_cod,
            lider_cod: null,
            ce_cod: ce_cod
        };
        
        return http.post(url, params);
    };
    
    /**
     * Retorna o registro de uma determinada célula
     * @param {type} rcel_cod
     * @returns {unresolved}
     */
    this.getDadosReuniao = function (rcel_cod){
        var url = $rootScope.rootUrl+"Celula/getDadosReuniao";
        var params = {
            lg: loginService.getLgSession(),
            ig_cod: $rootScope.dispIg.ig_cod,
            rcel_cod: rcel_cod
        };
        
        return http.post(url, params);
    };
    
    this.salvarReuniaoCel = function (re){
        var url = $rootScope.rootUrl+"Celula/salvarReuniaoCel";
        
        re.lg = loginService.getLgSession();
        re.ce_ig_cod = $rootScope.dispIg.ig_cod;
        re.ce_lider_cod = null;
        re.rcel_st = 1;
        
        var params = re;
        
        return http.post(url, params);
    };
    
    this.setStatusReuniao = function(rcel_cod, st){
        var url = $rootScope.rootUrl + "Celula/setStatusReuniao";
        var params = {
            lg: loginService.getLgSession(),
            ig_cod: localStorage.getItem('disp_ig_cod'),
            rcel_cod: rcel_cod,
            st: st
        };

        return http.post(url, params);
    };
    
    this.transfReuniaoPara = function(rcel_cod, novadata){
        var url = $rootScope.rootUrl + "Celula/transfReuniaoPara";
        var params = {
            lg: loginService.getLgSession(),
            ig_cod: localStorage.getItem('disp_ig_cod'),
            rcel_cod: rcel_cod,
            data_para: novadata
        };

        return http.post(url, params);
    };
    
    
    /**
     * Compartilhar Célula
     * @param {type} i
     * @returns {undefined}
     */
    this.sendCelulaSharing = function(i){
        var msg = "Célula: " + i.ce_nome + " - Líder: " + i.us_nome + " (Fone: " + Util.formatTelString(i.us_cel) + ") - Dia:" + Util.getSemanaTxt(i.ce_dia_semana_reuniao) + " Hora: " + i.ce_hora_reuniao.substr(0,5) + " - " + i.ce_logradouro + " Nº " + i.ce_num + " - Bairro: " + i.ce_bairro + " - " + i.ce_cidade + "/" + i.ce_uf;
        window.plugins.socialsharing.share(msg, i.ev_titulo);            
    };
    
}]);

