app.controller('reuniaoPorStatusController', ['$scope', '$rootScope', '$location', '$routeParams', 'Util', 'rede_celulas_arr', 'reuniaoPorStatusService', 'loginService', function ($scope, $rootScope, $location, $routeParams, Util, rede_celulas_arr, reuniaoPorStatusService, loginService) {
        loginService.acessoLogado();
        
        $rootScope.navtop.btnBack = true;
        $rootScope.navtop.title = "Reuniões por período";

        $scope.rede_celulas_arr = rede_celulas_arr;
        
        $scope.loader = false;
        $scope.paginacao_stop = false;
        $scope.pg = 0;

        $scope.search_modo = false;
        $scope.search = "start";

        $scope.ce = [];
        $scope.to = {};
        
        $scope.info_ce_s = {};
        $scope.relcel_ce_s = {};
        $scope.filtro = {};
        
        $scope.filtro.st = 0;

        $scope.init = function () {
            $scope.filtro.rcel_dataref_ini = $routeParams.dataref_ini;
            $scope.filtro.rcel_dataref_fim = $routeParams.dataref_fim;
            //$scope.getCelulasPorPeriodoSelecEmReuniaoCelula(true);
        };

        $scope.getSemanaTxt = function (dia_semana) {
            return Util.getSemanaTxt(dia_semana);
        };

        /**
         * Recebe mensagens de outro controller
         */
        $scope.$on('handleBroadcast', function (event, args) {
            if (args.path.indexOf("/reunioesporstatus") != -1) {                
                if (args.tipo === "scroll") {                    
                    if ($(window).scrollTop() + $(window).height() >= $(document).height() - 80){
                        console.log($scope.paginacao_stop);
                        if (!$scope.loader && !$scope.paginacao_stop) {
                            $scope.getCelulasPorPeriodoSelecEmReuniaoCelula();
                        }
                    }
                }
            }
        });
        
        $scope.selecCelulaParaInfoCelModal = function(i){
            $scope.info_ce_s = i;
            $scope.info_ce_s.random = Math.random();//Importante
            $("#infoCelulaModal").modal('show');
        };
        $scope.selecCelulaParaRelCelModal = function(i){
            $scope.relcel_ce_s = i;
            $scope.relcel_ce_s.random = Math.random();//Importante
            $("#relCelModal").modal('show');
        };
        $scope.selecCelulaParaDetalhesDaReunicaoModal = function(i){
            $scope.relcel_ce_s = i;
            $scope.relcel_ce_s.random = Math.random();//Importante
            $("#detalhesReuniaoModal").modal('show');
        };

        /**
         * Retorna registros paginados
         * @param {type} filtpesq
         * @returns {undefined}
         */
        $scope.getCelulasPorPeriodoSelecEmReuniaoCelula = function (filtpesq, somente_com_conversoes) {
            $scope.loader = true;
            $scope.filtro.somente_com_conversoes = somente_com_conversoes ? true : false;
            
            if (filtpesq) {
                $scope.pg = 0;
                $scope.paginacao_stop = false;
                $scope.ce = [];
                if ($scope.search.length > 0)
                    $scope.filtro.rede_cod = null;
            }

            reuniaoPorStatusService.getCelulasPorPeriodoSelecEmReuniaoCelula($scope.pg, $scope.search, $scope.filtro).success(function (data) {
                if (data.result === "logout") {
                    loginService.setLogout();
                    $scope.loader = false;
                    return false;
                }

                $scope.pg = $scope.pg + 1;
                if ($scope.pg >= data.result.max_pag) {
                    $scope.paginacao_stop = true;
                }

                //$scope.ce = data.result.dados;
                data.result.dados.forEach(function (dados) {
                    $scope.ce.push(dados);//Por causa da paginação
                });

                $scope.loader = false;
            }).error(function (data, status, headers, config) {
                Util.alertErrorMessage(data, status);
                $scope.loader = false;
            });
        };
        
        
        /**
        * get Desempenho
        * @returns {undefined}
        */
        $scope.getTotalizPorPeriodoReuniaoDeCelulas = function () {
            $scope.loader = true;

            reuniaoPorStatusService.getTotalizPorPeriodoReuniaoDeCelulas($scope.filtro).success(function (data) {
                if (data.result === "logout") {
                    loginService.setLogout();
                    $scope.loader = false;
                    return false;
                }

                $scope.to = data.result;

                $scope.loader = false;
            }).error(function (data, status, headers, config) {
                Util.alertErrorMessage(data, status);
                $scope.loader = false;
            });
        };

        /**
         * Start
         */
        $scope.init();
    
    
    
    }]);

