app.service('reuniaoPorStatusService', ['$rootScope', 'http', 'loginService', function($rootScope, http, loginService){
    
    /**
     * Retorna registros paginados de células por período e status
     * @param {type} pg
     * @param {type} search
     * @param {type} filtro
     * @returns {unresolved}
     */
    this.getCelulasPorPeriodoSelecEmReuniaoCelula = function (pg, search, filtro) {
        var url = $rootScope.rootUrl+"Celula/getCelulasPorPeriodoSelecEmReuniaoCelulaAll";
        
        var params = {
            lg: loginService.getLgSession(),
            parameter: search,
            pg: pg + 1,
            regporpag: 12,
            ce_ig_cod: $rootScope.dispIg.ig_cod,
            us_cod: $rootScope.lg.us_cod,
            filtro: filtro
        };
        
        return http.post(url, params);
    };
    
    
    this.getTotalizPorPeriodoReuniaoDeCelulas = function (filtro) {
        var url = $rootScope.rootUrl+"Celula/getTotalizPorPeriodoReuniaoDeCelulas";
        
        var params = {
            lg: loginService.getLgSession(),
            ce_ig_cod: $rootScope.dispIg.ig_cod,
            us_cod: $rootScope.lg.us_cod,
            filtro: filtro
        };
        
        return http.post(url, params);
    };
    
}]);



