app.directive('vsSendFotoUs', function () {
    return {
        restrict: 'EA',
        templateUrl: 'app/c/us/tpls/sendfotoUs.html',
        scope: {
            srcFoto: '='
        },
        controller: function ($scope, $rootScope, Util) {
            $scope.perc = 0;

            $scope.init = function () {

            };
            
            $scope.$watch('srcFoto', function(nv){                
                $scope.src_f = nv+"?"+Util.random();
            });

            /**
             * Capturar foto da câmera
             * @returns {undefined}
             */
            $scope.captureFotoCameraFotoPerfil = function () {
                navigator.camera.getPicture($scope.onFotoCameraFotoPerfilFileSuccess, $scope.onFailFotoPerfil, {
                    quality: 80,
                    targetWidth: 150,
                    correctOrientation: true,
                    destinationType: Camera.DestinationType.FILE_URI,
                    sourceType: Camera.PictureSourceType.CAMERA,
                    encodingType: Camera.EncodingType.JPEG,
                    mediaType: Camera.MediaType.PICTURE,
                    saveToPhotoAlbum: false,
                    cameraDirection: Camera.Direction.FRONT
                });
            };
            $scope.onFotoCameraFotoPerfilFileSuccess = function (imageData) {
                //$scope.src_f = imageData;

                //Upload para o servidor
                var ig_cod = $rootScope.dispIg.ig_cod;
                var us_cod = $rootScope.lg.us_cod;
                var img_nome = ig_cod + "_" + us_cod + ".jpg";
                $scope.uploadFotoPerfil(imageData, "image/jpeg", img_nome, us_cod, ig_cod);
            };
            

            /**
             * Selecionar foto da galeria
             * @returns {undefined}
             */
            $scope.getFotoGaleriaFotoPerfil = function () {
                navigator.camera.getPicture($scope.onFotoGaleriaFotoPerfilURISuccess, $scope.onFailFotoPerfil, {
                    quality: 35,
                    targetWidth: 150,
                    destinationType: Camera.DestinationType.FILE_URI,
                    sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                    encodingType: Camera.EncodingType.JPEG
                            //,mediaType: Camera.MediaType.PICTURE//Opções: PICTURE, VIDEO ou ALLMEDIA
                });
            };
            $scope.onFotoGaleriaFotoPerfilURISuccess = function (imageURI) {
                //$scope.src_f = imageURI;
                
                var ig_cod = $rootScope.dispIg.ig_cod;
                var us_cod = $rootScope.lg.us_cod;
                var img_nome = ig_cod + "_" + us_cod + ".jpg";
                $scope.uploadFotoPerfil(imageURI, "image/jpeg", img_nome, us_cod, ig_cod);
            };

            /**
             * Enviar foto para o servidor
             * @param {type} fileURL
             * @param {type} mime
             * @param {type} nome_arq
             * @param {type} us_cod
             * @param {type} ig_cod
             * @returns {undefined}
             */
            $scope.uploadFotoPerfil = function (fileURL, mime, nome_arq, us_cod, ig_cod) {
                var uri = encodeURI($rootScope.rootUrl + "upload_file_perfil.php");
                
                var options = new FileUploadOptions();
                options.fileKey = "file";
                options.fileName = nome_arq ? nome_arq : fileURL.substr(fileURL.lastIndexOf('/') + 1);
                options.mimeType = mime;
                options.chunkedMode = true;//Padrão é true
                options.headers = {
                    Connection: "close"
                };

                var params = {};
                params.ig_cod = ig_cod;
                params.us_cod = us_cod;

                options.params = params;

                var ft = new FileTransfer();

                ft.onprogress = function (progressEvent) {
                    if (progressEvent.lengthComputable) {
                        $scope.$apply(function () {
                            $scope.perc = Math.floor(progressEvent.loaded / progressEvent.total * 100);
                        });                            
                    } else {
                        //               
                    }
                };
                ft.upload(fileURL, uri, function (result) {
                    //alert('Upload realizado com sucesso: ' + result.responseCode) + '. bytes enviados: ' + result.bytesSent;
                    
                    setTimeout(function(){
                        $scope.$apply(function () {
                            $scope.perc = 0;
                            $scope.editfoto = false;                        
                            
                            $scope.src_f = $scope.srcFoto+"?"+Util.random();
                        });                            
                    }, 1000);
                },
                        function (error) {
                            var erro_txt = "";
                            if (error.code === FileTransferError.FILE_NOT_FOUND_ERR) {
                                erro_txt = "arquivo não encontrado";
                            } else if (error.code === FileTransferError.INVALID_URL_ERR) {
                                erro_txt = "URL inválida";
                            } else if (error.code === FileTransferError.CONNECTION_ERR) {
                                erro_txt = "Erro de conexão";
                            } else if (error.code === FileTransferError.ABORT_ERR) {
                                erro_txt = "Operação abortada";
                            }

                            options = null;
                            ft = null;
                            $scope.$apply(function () {
                                $scope.perc = 0;
                                $scope.editfoto = false;                        

                                $scope.src_f = $scope.srcFoto+"?"+Util.random();
                            }); 
                            navigator.notification.alert(erro_txt + ' - Erro nº: ' + error.code, null, 'Erro');
                        },
                        options);
            };


            $scope.onFailFotoPerfil = function (message) {
                //alert('Motivo da falha: ' + message);
            };


            $scope.init();
        }
    };
});


