app.controller('videoController', ['$scope', '$rootScope', '$location', 'Util', 'videoService', function ($scope, $rootScope, $location, Util, videoService) {
        $rootScope.navtop.btnBack = true;
        $rootScope.navtop.title = "Vídeos";

        $scope.vd_cats = [];

        $scope.loader = false;
        $scope.paginacao_stop = false;
        $scope.pg = 0;

        $scope.search_modo = false;
        $scope.search = "";

        $scope.vd = [];
        $scope.vd_s = [];
        $scope.filtro = {};

        $scope.init = function () {
            $scope.getListsForSelectCategVideo();
        };

        /**
         * Recebe mensagens de outro controller
         */
        $scope.$on('handleBroadcast', function (event, args) {
            if (args.path === "/video") {
                if (args.tipo === "scroll") {
                    if ($(window).scrollTop() + $(window).height() >= $(document).height() - 80) {
                        if (!$scope.loader && $scope.paginacao_stop === false) {
                            $scope.getVideosSearchAll();
                        }
                    }
                }
            }
        });

        $rootScope.$watch('search_submit', function (newValue, oldValue) {
            if (newValue === true) {                
                $scope.getVideosSearchAll(true);
            }
        });

        $scope.limparSearch = function () {
            $rootScope.search = "";
            $("#search").val("");
        };

        $scope.getListsForSelectCategVideo = function () {
            videoService.getListsForSelectCategVideo().success(function (data) {
                $scope.vd_cats = data.result;
                $scope.getVideosSearchAll(true);
            }).error(function (data, status, headers, config) {
                Util.alertErrorMessage(data, status);
                $scope.loader = false;
            });
        };

        /**
         * Retorna registros paginados das células ativas
         * @param {type} filtpesq
         * @returns {undefined}
         */
        $scope.getVideosSearchAll = function (filtpesq) {
            $scope.loader = true;

            if (filtpesq) {
                $scope.pg = 0;
                $scope.paginacao_stop = false;
                $scope.vd = [];
                if ($scope.search.length > 0)
                    $scope.filtro = {};
            }

            videoService.getVideosSearchAll($scope.pg, $scope.search, $scope.filtro).success(function (data) {
                $scope.pg = $scope.pg + 1;
                if ($scope.pg >= data.result.max_pag) {
                    $scope.paginacao_stop = true;
                }

                //$scope.vd = data.result.dados;
                angular.forEach(data.result.dados, function (d) {
                    $scope.vd.push(d);//Por causa da paginação
                });

                $scope.loader = false;
            }).error(function (data, status, headers, config) {
                Util.alertErrorMessage(data, status);
                $scope.loader = false;
            });
        };
        
        /**
        * Compartilhar Vídeo
        * @param {arrayDeObjetos} i - Dados do Vídeo
        * @returns {undefined}
        */
        $scope.sendVideoSharing = function (i) {
            videoService.sendVideoSharing(i);
        };


        $scope.selec = function (i) {
            $scope.vd_s = i;
            $("#videoModal").modal('show');
        };
       
        /** VIDEO **/
        $('#videoModal').on('hidden.bs.modal', function () {
            $scope.vd_s = [];
            $scope.stopVideo();
        });
        $scope.stopVideo = function(){
            $scope.viewVideoPlayer.stopVideo();
        };
        /** /VIDEO **/


        /**
         * Start
         */
        $scope.init();
    }]);




