var wfpag = angular.module('wfPagination', []);

wfpag.directive("wfPaginationMesAno", function () {
    return {
        restrict: 'EA',
        replace: true,
        templateUrl: 'app/libs/wfpagination/wfpaginationMesAnoTpl.html',
        scope: {
            pag: '=',
            onGet: '&'
        },
        controller: function ($scope, $filter) {

            $scope.setPgEdit = function () {
                $scope.setMesAnoTxt();
                $scope.pag.pg_modo_edit = false;
                $scope.onGet();
            };

            $scope.setMesAnoTxt = function () {
                $scope.pag.mes_ano_txt = $filter('mestxt')($scope.pag.mes, true) + "/" + $scope.pag.ano;
            };

            $scope.cancelPgEdit = function () {
                $scope.pag.pg_modo_edit = false;
                $scope.pag.pg_edit = $scope.pag.pg;
            };

            $scope.mesAntPg = function () {
                $scope.acrescUmMesPg(-1);
                $scope.onGet();
            };
            $scope.proxMesPg = function () {
                $scope.acrescUmMesPg(1);
                $scope.onGet();
            };

            $scope.acrescUmMesPg = function (dc) {
                $scope.pag.mes = $scope.pag.mes < 10 ? "0" + $scope.pag.mes : $scope.pag.mes;
                var data = $scope.pag.ano + "-" + $scope.pag.mes + "-01T10:20:30Z";

                var now = new Date(data);
                var month = now.getMonth();
                var year = now.getFullYear();
                var ac = new Date(year, eval(dc + month), 1);

                var pm = new Date(ac);
                var mes = pm.getMonth() + 1;
                var ano = pm.getFullYear();
                $scope.pag.mes = mes+"";
                $scope.pag.ano = parseInt(ano);
                $scope.setMesAnoTxt();
            };

            $scope.verifPg = function () {
                if (!angular.isNumber($scope.pag.ano)) {
                    var now = new Date();
                    $scope.pag.ano = parseInt(now.getFullYear());
                    $scope.setMesAnoTxt();
                    return false;
                }
                return true;
            };
        }
    };
});


wfpag.directive("wfPaginationAno", function () {
    return {
        restrict: 'EA',
        replace: true,
        templateUrl: 'app/libs/wfpagination/wfpaginationAnoTpl.html',
        scope: {
            pag: '=',
            onGet: '&'
        },
        controller: function ($scope, Util) {

            $scope.setPgEdit = function () {
                $scope.pag.pg_modo_edit = false;
                $scope.onGet();
            };

            $scope.cancelPgEdit = function () {
                $scope.pag.pg_modo_edit = false;
                $scope.pag.pg_edit = $scope.pag.pg;
            };

            $scope.anoAntPg = function () {
                $scope.pag.ano--;
                $scope.onGet();
            };
            $scope.proxAnoPg = function () {
                $scope.pag.ano++;
                $scope.onGet();
            };
        }
    };
});


wfpag.factory('wfPaginationService', function () {
    var getTxtMes = function (m, abrev) {
        var meses = {1: "Janeiro", 2: "Fevereiro", 3: "Março", 4: "Abril", 5: "Maio", 6: "Junho", 7: "Julho", 8: "Agosto", 9: "Setembro", 10: "Outubro", 11: "Novembro", 12: "Dezembro"};
        var meses_abrev = {1: "Jan", 2: "Fev", 3: "Mar", 4: "Abr", 5: "Mai", 6: "Jun", 7: "Jul", 8: "Ago", 9: "Set", 10: "Out", 11: "Nov", 12: "Dez"};

        //if(m<10) m = m.substr(1,1);
        if (abrev)
            return meses_abrev[m];
        return meses[m];
    };

    return {
        getPagMesAnoAtual: function () {
            var d = new Date();
            var _mes = d.getMonth() + 1 + "", _ano = d.getFullYear();
            return {mes: _mes, ano: _ano, mes_ano_txt: getTxtMes(_mes, true) + "/" + _ano};
        }
    };
});